<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: atracking.php,v 1.5 2002/12/09 14:49:32 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

$ctime = time() + $config["General"]["timezone_offset"];

if (empty($StartMonth) || empty($StartDay) || empty($StartYear) || empty($EndMonth) || empty($EndDay) || empty($EndYear)) {
	$start_date = mktime(0,0,0,date("m",$ctime),date("d",$ctime),date("Y",$ctime));
	$end_date = $ctime;
}
else {
	$start_date = mktime(0,0,0,$StartMonth,$StartDay,$StartYear);
	$end_date = mktime(23,59,59,$EndMonth,$EndDay,$EndYear);
}

$date = "date+'".$config["General"]["timezone_offset"]."'";
$date_condition = "($date>='$start_date' AND $date<='$end_date')";

$cart_funnel = array_pop(func_query_first("SELECT COUNT(*) FROM $sql_tbl[stats_cart_funnel] WHERE $date_condition"));

$all_views = array_pop(func_query_first("SELECT COUNT(*) FROM $sql_tbl[stats_pages_views] WHERE $date_condition"));

if ($mode == "pagesviews") {
    $statistics = func_query("SELECT p.page, COUNT(pv.pageid) as views, ROUND(AVG(pv.time_avg)) as time_avg FROM $sql_tbl[stats_pages_views] as pv, $sql_tbl[stats_pages] as p WHERE p.pageid=pv.pageid AND $date_condition GROUP BY p.page ORDER BY views DESC, time_avg DESC LIMIT 50");
}
elseif ($mode == "toppaths") {
    $all_views = array_pop(func_query_first("SELECT COUNT(*) FROM $sql_tbl[stats_pages_paths] WHERE path LIKE '%-%' AND $date_condition"));
    $statistics = func_query("SELECT DISTINCT path, COUNT(path) as counter FROM $sql_tbl[stats_pages_paths] WHERE path LIKE '%-%' AND $date_condition GROUP BY path ORDER BY counter DESC LIMIT 25");
    if ($statistics)
        foreach($statistics as $k=>$v) {
            $pages = split("-", $v[path]);
            foreach($pages as $k1=>$v1) {
				$query = "SELECT p.page, ROUND(AVG(pv.time_avg),2) as time_avg FROM $sql_tbl[stats_pages_views] as pv, $sql_tbl[stats_pages] as p WHERE p.pageid=pv.pageid AND pv.pageid='$v1' AND $date_condition GROUP BY p.page";
                $tmp = func_query_first($query);
                $statistics[$k][pages][] = $tmp;
            }
        }
}
elseif ($mode == "cartfunnel" && $cart_funnel > 0) {

    $statistics[0][step] = "product_page";
    $statistics[0][visits] = array_pop(func_query_first("SELECT COUNT(pv.pageid) FROM $sql_tbl[stats_pages_views] as pv, $sql_tbl[stats_pages] as p WHERE p.pageid=pv.pageid AND p.page LIKE '%product.php?productid=%' AND $date_condition"));
    $statistics[0][percent_all] = sprintf("%2.02f", ( $statistics[0][visits] / ($all_views?$all_views:1) ) * 100);
    $statistics[1][step] = "start_page";
    $statistics[1][visits] = array_pop(func_query_first("SELECT count(start_page) FROM $sql_tbl[stats_cart_funnel] WHERE start_page>0 AND $date_condition"));
    $statistics[1][percent_parent] = sprintf("%2.02f", ( $statistics[1][visits] / ($statistics[0][visits]?$statistics[0][visits]:1) ) * 100);
    $statistics[1][percent_all] = sprintf("%2.02f", ( $statistics[1][visits] / ($all_views?$all_views:1) ) * 100);
    $statistics[2][step] = "step1";
    $statistics[2][visits] = array_pop(func_query_first("SELECT count(step1) FROM $sql_tbl[stats_cart_funnel] WHERE step1>0 AND $date_condition"));
    $statistics[2][percent_parent] = sprintf("%2.02f", ( $statistics[2][visits] / ($statistics[1][visits]?$statistics[1][visits]:1) ) * 100);
    $statistics[2][percent_all] = sprintf("%2.02f", ( $statistics[2][visits] / ($all_views?$all_views:1) ) * 100);
    $statistics[3][step] = "step2";
    $statistics[3][visits] = array_pop(func_query_first("SELECT count(step2) FROM $sql_tbl[stats_cart_funnel] WHERE step2>0 AND $date_condition"));
    $statistics[3][percent_parent] = sprintf("%2.02f", ( $statistics[3][visits] / ( $statistics[1][visits] + $statistics[2][visits] ) ) * 100);
    $statistics[3][percent_all] = sprintf("%2.02f", ( $statistics[3][visits] / ($all_views?$all_views:1) ) * 100);
    $statistics[3][percent_parent2] = sprintf("%2.02f", ( $statistics[3][visits] / ($statistics[0][visits]?$statistics[0][visits]:1) ) * 100);
    $statistics[4][step] = "step3";
    $statistics[4][visits] = array_pop(func_query_first("SELECT count(step3) FROM $sql_tbl[stats_cart_funnel] WHERE step3>0 AND $date_condition"));
    $statistics[4][percent_parent] = sprintf("%2.02f", ( $statistics[4][visits] / ($statistics[3][visits]?$statistics[3][visits]:1) ) * 100);
    $statistics[4][percent_all] = sprintf("%2.02f", ( $statistics[4][visits] / ($all_views?$all_views:1) ) * 100);
    $statistics[5][step] = "final_page";
    $statistics[5][visits] = array_pop(func_query_first("SELECT count(final_page) FROM $sql_tbl[stats_cart_funnel] WHERE final_page>0 AND $date_condition"));
    $statistics[5][percent_parent] = sprintf("%2.02f", ( $statistics[5][visits] / ($statistics[4][visits]?$statistics[4][visits]:1) ) * 100);
    $statistics[5][percent_all] = sprintf("%2.02f", ( $statistics[5][visits] / ($all_views?$all_views:1) ) * 100);
}

$smarty->assign("mode", $mode);
$smarty->assign("start_date", $start_date);
$smarty->assign("end_date", $end_date);
$smarty->assign("all_views", $all_views);
$smarty->assign("statistics", $statistics);
$smarty->assign("main","atracking");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
