<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: languages.php,v 1.21 2002/12/06 07:06:52 alfiya Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

$topics = array ("Labels", "Text", "Errors", "E-Mail");

if (!$topic)
	$topic = $topics [0];

$d_langs = explode (",", $config["disabled_languages"]);
if ($d_langs) {
	foreach ($d_langs as $key=>$value) {
		$d_langs [$key] = trim ($value);
	}
}

$languages = func_query ("SELECT DISTINCT($sql_tbl[languages].code), $sql_tbl[countries].country, $sql_tbl[countries].language FROM $sql_tbl[languages], $sql_tbl[countries] WHERE $sql_tbl[languages].code=$sql_tbl[countries].code GROUP BY $sql_tbl[languages].code");

//?????????

if ($languages) {
	foreach ($languages as $key=>$value) {
		if (in_array ($value["language"], $d_langs))
			$languages[$key]["disabled"] = "Y";
		else
			$languages[$key]["disabled"] = "N";
	}
}

if ($mode == "update") {

	include "safe_mode.php";

	if ($var_name) {
		foreach ($var_name as $key=>$value) {
			db_query ("UPDATE $sql_tbl[languages] SET descr='$var_descr[$value]', value='$var_value[$value]' WHERE code='$language' AND name='$value'");
		}
	}

	if ($new_var_name) {
		$mr = func_query_first ("SELECT * FROM $sql_tbl[languages] WHERE name='$new_var_name' AND code='$language'");
		if ($mr) {
			db_query ("UPDATE $sql_tbl[languages] SET descr='$new_var_descr', value='$new_var_value' WHERE name='$new_var_name' AND code='$language'");
		} else {
			foreach ($languages as $key=>$value)
				db_query ("INSERT INTO $sql_tbl[languages] (code, descr, name, value, topic) VALUES ('$value[code]','$new_var_descr','$new_var_name','$new_var_value','$topic')");
		}
	}

	header ("Location: languages.php?language=$language&page=$page&filter=".urlencode($filter)."&topic=$topic&updated");
	exit;
}

if ($mode == "delete") {

	include "safe_mode.php";

	db_query ("DELETE FROM $sql_tbl[languages] WHERE name='$var' and  code='$language'");
	
	header ("Location: languages.php?language=$language&page=$page&filter=".urlencode($filter)."&deleted");
	exit;
}

if ($mode == "del_lang") {

	include "safe_mode.php";

	db_query ("DELETE FROM $sql_tbl[languages] WHERE code='$language'");
	db_query ("DELETE FROM $sql_tbl[products_lng] WHERE code='$language'");
	header ("Location: languages.php?lang_deleted");
	exit;
}

if (($mode == "export") and ($language)) {
	$smarty->assign ("csv_delimiter", $delimiter);

	$lng_res = func_query_first ("SELECT language FROM $sql_tbl[countries] WHERE code='$language'");

	$data = func_query ("SELECT * FROM $sql_tbl[languages] WHERE code='$language' ORDER BY name");
	if ($data) {
		foreach ($data as $key=>$value) {
			$data[$key]["value"] = "\"" . eregi_replace ("\"", "\"\"", $value["value"]) . "\"";
			$data[$key]["descr"] = "\"" . eregi_replace ("\"", "\"\"", $value["descr"]) . "\"";
		}

		$smarty->assign ("data", $data);

		header ("Content-Type: text/csv");
		header ("Content-Disposition: attachment; filename=lng_$lng_res[language].csv");

		$_tmp_smarty_debug = $smarty->debugging;
		$smarty->debugging = false;

		$smarty->display ("main/lng_export.tpl");

		$smarty->debugging = $_tmp_smarty_debug;
		exit;
	}
}

//???????

$_new_languages = func_query ("SELECT * FROM $sql_tbl[countries] WHERE language!='' ORDER BY language"); 
# Strip off existing languages

$new_languages = array ();
if (false) { #($_new_languages) {
	foreach ($_new_languages as $key=>$value) {
		$found = false;
		if ($languages) {
			foreach ($languages as $subkey=>$subvalue) {
				if ($value["code"] == $subvalue["code"])
					$found = true;
			}
		}
		if (!$found)
			$new_languages [] = $value;
	}
}
$new_languages = $_new_languages;

if ($mode == "add_lang") {

	include "safe_mode.php";

	if (!$new_language) {
		header ("Location: languages.php");
		exit;
	}

	$exists_result = func_query_first ("SELECT * FROM $sql_tbl[languages] WHERE code='$new_language'");

	if (!$exists_result) {
		$result = func_query ("SELECT * FROM $sql_tbl[languages] WHERE code='$config[default_customer_language]'");
		if ($result) {
			foreach ($result as $key=>$value) {
				db_query ("INSERT INTO $sql_tbl[languages] (code, descr, name, value, topic) VALUES ('$new_language', '".addslashes($value[descr])."', '".addslashes($value[name])."','".addslashes($value[value])."','$value[topic]')");
			}
		}
	}

	if (($import_file) and ($import_file != "none")) {
		if ($fp = @fopen($import_file, "r")) {
			$lngs = func_query ("SELECT DISTINCT($sql_tbl[languages].code), $sql_tbl[countries].* FROM $sql_tbl[languages], $sql_tbl[countries] WHERE $sql_tbl[languages].code=$sql_tbl[countries].code");
			while ($columns = fgetcsv ($fp, 65536, $delimiter)) {
				if (sizeof($columns) == 4) {
					$res = func_query_first ("SELECT * FROM $sql_tbl[languages] WHERE name='$columns[0]' AND $sql_tbl[languages].code = '$new_language' LIMIT 1");
					if ($res) {
						db_query ("UPDATE $sql_tbl[languages] SET value='".addslashes($columns[1])."', descr='".addslashes($columns[2])."', topic='".addslashes($columns[3])."' WHERE name='$columns[0]' AND code='$new_language'");
					} else {
						db_query ("INSERT INTO $sql_tbl[languages] (code, descr, name, value, topic) VALUES ('$new_language','".addslashes ($columns[2])."','$columns[0]','".addslashes ($columns[1])."','".addslashes ($columns[3])."')");
					}
				}
			}
			fclose ($fp);
		}
	}

	header ("Location: languages.php?language=$new_language&topic=$topic&page=$page");
	exit;
}

if (($mode == "change") and ($language)) {

	include "safe_mode.php";

	$result = func_query_first ("SELECT * FROM $sql_tbl[countries] WHERE code='$language'");

	$new_langs = array ();
	
	if (in_array ($result["language"], $d_langs)) {
		foreach ($d_langs as $k=>$v) {
			if ($v != $result["language"])
				$new_langs [] = $v;
		}
		$d_langs = $new_langs;
	} else {
		$d_langs [] = $result["language"];
	}

	$t_langs = array ();

	if ($d_langs) {
		foreach ($d_langs as $key=>$value) {
			if ($value)
				$t_langs [] = $value;
		}
	}

	$disabled_languages = implode (",", $t_langs);
	db_query ("UPDATE $sql_tbl[config] SET value='$disabled_languages' WHERE name='disabled_languages'");

	header ("Location: languages.php?language=$language&mode_changed");
	exit;
}
if ($mode == "change_defaults") {

	if (!empty($new_customer_language))
		db_query("update $sql_tbl[config] set value='$new_customer_language' where name='default_customer_language'");
	if (!empty($new_admin_language))
		db_query("update $sql_tbl[config] set value='$new_admin_language' where name='default_admin_language'");

	header ("Location: languages.php?language=$language");
	exit;
}

if ($language) {
	$r = func_query_first ("SELECT language, charset FROM $sql_tbl[countries] WHERE code='$language'");
	$smarty->assign ("default_charset", $r[charset]);

	if (in_array ($r["language"], $d_langs)) {
		$lang_disabled = "Y";
	} else {
		$lang_disabled = "N";
	}

	$smarty->assign ("lang_disabled", $lang_disabled);
	
	$topic_condition = " AND topic='$topic' ";
	$query = "SELECT * FROM $sql_tbl[languages] WHERE code='$language' AND (name LIKE '%$filter%' OR descr LIKE '%$filter%' or value LIKE '%$filter%') $topic_condition order by name";

	$objects_per_page = 20;

	$total_products_in_search = count (func_query ($query));
	$total_nav_pages = ceil ($total_products_in_search/$objects_per_page)+1;
	require "../include/navigation.php";
	
	$smarty->assign ("data", func_query ("$query LIMIT $first_page, $objects_per_page"));

	$smarty->assign ("navigation_script", "languages.php?language=$language&topic=$topic&filter=".urlencode($filter));
}

$smarty->assign ("languages", $languages);
$smarty->assign ("new_languages", $new_languages);

$smarty->assign ("topics", $topics);

$smarty->assign("main","languages");
@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
