<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: patch.php,v 1.13 2002/11/19 13:00:15 novik Exp $
#

set_time_limit(1800);

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

$upgrade_repository = "../upgrade";
$upgrade_absolute_path = "./upgrade";
$patch_exe = "patch.pl";
$patch_tmp_folder = "../templates_c/upgrade";
$patch_logfile = "$patch_tmp_folder/patch.log";

require "./patch_sql.php";

function files_to_patch ($patch_lines) {

	$files_to_patch = array();
	$all_files_to_patch = array();

	foreach($patch_lines as $patch_line) {
		if(substr($patch_line, 0,5)=="Index") {
			$file_to_patch = chop(ereg_replace("Index: ","",$patch_line));

			if(!is_writable("../".$file_to_patch)) {
				$all_files_to_patch[] = array("filename"=>$file_to_patch,"status"=>"NO");
				$files_to_patch[] = $file_to_patch;
			} else {
				$all_files_to_patch[] = array("filename"=>$file_to_patch,"status"=>"OK");
			}
		}
	}

	return(array($files_to_patch, $all_files_to_patch));
}

if ($REQUEST_METHOD=="POST") {
#
#  Patch by file upload
#
    if (($patch_file!="none")&&($patch_file!="")) {
		move_uploaded_file($patch_file, "$file_temp_dir/$patch_file_name");
		$patch_filename=$patch_file_name;
    }
	elseif ($patch_url!="") {
#
# Patch is downloaded from URL
#
		if($patch_lines = @file($patch_url)) {
#
# Write file to $file_temp_dir
#
			$parsed_url = parse_url($patch_url);
			$patch_filename = basename($parsed_url["path"]);	

			$fw = fopen("$file_temp_dir/$patch_filename","w");
			foreach($patch_lines as $patch_line)
				fputs($fw, $patch_line);

			fclose($fw);
		}
		else {
			header ("Location: error_message.php?cant_open_file");
			exit;
		}

	}
	elseif($patch_query) {
#
# Save custom queries into file
#

		$patch_filename="query".time();

		$fw = fopen("$file_temp_dir/$patch_filename","w");
		fputs($fw, stripslashes($patch_query));
		fclose($fw);

	}

#
# Perform upgrade
#
	if ($mode=="upgrade" && $patch_filename) {
#
# Read all .diff files from $upgrade_repository/$target_version
#

#
# target version is stored in patch_filename variable
#
		$target_version     = $patch_filename;
		$patch_files_lst    = "$upgrade_repository/$target_version/file.lst";
		$patch_files        = array();
		$integrity_result   = array();
		$files_to_patch     = array();
		$all_files_to_patch = array();
		$patch_lines        = array();

		if ($_patch_files = @file($patch_files_lst)) {
#
# Parse patch info
#
			foreach($_patch_files as $patch_file_info) {
				if (!preg_match("/^$/", chop($patch_file_info)) && !preg_match("/^#/", chop($patch_file_info))) {
					list($orig_file, $diff_file, $md5_sum) = preg_split( "/[ ,\t]+/", $patch_file_info);

					array_push($patch_files, array("orig_file" => $orig_file,
					                               "diff_file" => $diff_file,
												   "md5_sum"   => chop($md5_sum),
												   "status"    => "OK"));
				} 
			}
#
# Check patch integrity and permissions
#
			foreach($patch_files as $patch_file_info) {

				# check ontegrity
				if ($md5_file = @file("$upgrade_repository/$target_version/".$patch_file_info["diff_file"])) {
					if (count($patch_lines) < 150)
						$patch_lines = array_merge($patch_lines, $md5_file);

					if ($patch_file_info["md5_sum"] == md5(implode("", $md5_file))) {
						$integrity_result[] = array("filename" => $patch_file_info["diff_file"], "status" => "OK");
					} else {
						$integrity_result[] = array("filename" => $patch_file_info["diff_file"], "status" => "FAILED");
					}
				} else {
					$integrity_result[] = array("filename" => $patch_file_info["diff_file"], "status" => "FILE NOT FOUND");
				}

				# check permissions
				if (!is_writable("../".$patch_file_info["orig_file"])) {
					if (!is_file("../".$patch_file_info["orig_file"]))
						$all_files_to_patch[] = array("filename" => $patch_file_info["orig_file"], "status" => "FILE NOT FOUND");
					else
						$all_files_to_patch[] = array("filename" => $patch_file_info["orig_file"], "status" => "FAILED");

					$files_to_patch[] = $patch_file_info["orig_file"];
				} else {
					$all_files_to_patch[] = array("filename" => $patch_file_info["orig_file"], "status" => "OK");
				}
			}
		}

		$smarty->assign("patch_exe", array("patch_exe" => $patch_exe,
		                                      "status" => file_exists("../$patch_exe") ? (is_executable("../$patch_exe") ? "OK" : "FAILED") : "FILE NOT FOUND"));

		$patch_lines = array_merge($patch_lines, "\n\n --- skipped, see DIFF file(s) for full text ---");

		$smarty->assign("patch_text",htmlspecialchars(implode("",$patch_lines)));
		$smarty->assign("patch_filename",$target_version);
		$smarty->assign("patch_type","upgrade");
		$smarty->assign("all_files_to_patch",$all_files_to_patch);
		$smarty->assign("integrity_result",$integrity_result);

		if (!empty($files_to_patch) or !empty($integrity_result)) {
#
# Confirm permissions
#
			$smarty->assign("files_to_patch",$files_to_patch);
			$smarty->assign("confirm_patch","Y");

		}
		
		if(!$confirmed) {
			$smarty->assign("confirm_patch","Y");
		} elseif(empty($files_to_patch)) {
#
# Apply upgrade patches
#
			if (!is_dir($patch_tmp_folder) && !mkdir($patch_tmp_folder, 0777)) 
				$smarty->assign("patch_result", array("Failed to create work directory: $patch_tmp_folder"));

			if (is_dir($patch_tmp_folder))
				require "upgrade.php";
#
# Log patch activiry
#
			if (!@is_link($patch_logfile) and $LOG = fopen($patch_logfile, "a+")) {
				fputs($LOG, strftime("%T %D ", time()) . str_repeat("=", 5) . " START " . str_repeat("=", 25) . "\n");

				fputs($LOG, "PATCH FILES\n");
				foreach ($patch_files as $patch_file_info) {
					fputs($LOG, $patch_file_info["orig_file"] . " ... [" . $patch_file_info["status"] . "]\n");
				}

				fputs($LOG, "\nPATCH RESULTS\n");
				foreach ($patch_result as $patch_resul_str) {
					fputs($LOG, $patch_resul_str . "\n");
				}
				
				fputs($LOG, "\nPATCH LOG\n");
				foreach ($patch_log as $patch_log_str) {
					fputs($LOG, $patch_log_str . "\n");
				}

				fputs($LOG, str_repeat("=", 25) . " END " . str_repeat("=", 25) . "\n");
				fclose($LOG);
			}
		}
	}
	elseif ($patch_filename && $mode=="normal") {
#
# Generate 'files to patch' list
# A list of files needed to be patch but are not writeable
#
			
		$patch_lines = file("$file_temp_dir/$patch_filename");

		list($files_to_patch, $all_files_to_patch) = files_to_patch($patch_lines);

		$smarty->assign("patch_text",htmlspecialchars(implode("",$patch_lines)));
		$smarty->assign("patch_filename",$patch_filename);
		$smarty->assign("patch_type","text");
		$smarty->assign("all_files_to_patch",$all_files_to_patch);
		$smarty->assign("reverse",$reverse);

		if (!empty($files_to_patch)) {
#
# Confirm permissions
#
			$smarty->assign("files_to_patch",$files_to_patch);
			$smarty->assign("confirm_patch","Y");

		} elseif(!$confirmed) {
			$smarty->assign("confirm_patch","Y");
		} else {
#
# Apply patch
#
			require "safe_mode.php";

			$patch_result = array();
			
			if (!is_dir($patch_tmp_folder) && !mkdir($patch_tmp_folder, 0777)) 
				$smarty->assign("patch_result", array("Failed to create work directory: $patch_tmp_folder"));
				
			if (is_dir($patch_tmp_folder)) {
				exec ("cd ..; ./$patch_exe".($reverse=="Y"?" -R":"")." -N -f -l -Z -z -k templates_c/upgrade -j templates_c/upgrade -i templates_c/$patch_filename 2>&1",$patch_result,$patch_errorcode);
				$smarty->assign("patch_result", $patch_result);
			}

			@unlink("$file_temp_dir/$patch_filename");
		}

	}
	elseif ($patch_filename && $mode=="sql") {

		$patch_lines = file("$file_temp_dir/$patch_filename");

		$smarty->assign("patch_type","sql");
		$smarty->assign("patch_text",implode("",$patch_lines));
		$smarty->assign("patch_filename",$patch_filename);
		$smarty->assign("all_files_to_patch","foobar");

		if(!$confirmed) {
#
# Show confirmation
#
			$smarty->assign("confirm_patch","Y");
		}
		else {
#
# Apply SQL patch
#
			require "safe_mode.php";

			$patch_result = array();

			$sql_error = ExecuteSqlQuery(implode("",$patch_lines));
#
# Generate Result text
#
			if (!empty($sql_error)) {
				$patch_result[] = "<FONT color=red>SQL PATCH FAILED AT QUERY:</FONT>";
				$patch_result[] = $sql_error;
			}
			else {
				$patch_result[] = "The database was successfully patched !";
			}

			@unlink("$file_temp_dir/$patch_filename");
			$smarty->assign("patch_result",$patch_result);
		}

	}

	
}

#
# Get the list of target versions available in ./upgrade
#

if ($dir = @opendir($upgrade_repository)) {
    while (($file = readdir($dir)) !== false) {
		if (is_dir($upgrade_repository."/".$file) && $file!="." && $file!="..") {
			list($source_version,$target_version) = explode("-",$file,2);
        	if ($config["version"]==$source_version) $target_versions[]=$target_version;
		}
	}
		
    closedir($dir);
}


$smarty->assign("main","patch");
$smarty->assign("target_versions",$target_versions);

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
