<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: statistics.php,v 1.13 2002/12/09 14:49:32 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

$ctime = time() + $config["General"]["timezone_offset"];

if (empty($StartMonth) || empty($StartDay) || empty($StartYear) || empty($EndMonth) || empty($EndDay) || empty($EndYear)) {
    $start_date = mktime(0,0,0,date("m",$ctime),date("d",$ctime),date("Y",$ctime));
    $end_date = $ctime;
}
else {
    $start_date = mktime(0,0,0,$StartMonth,$StartDay,$StartYear);
    $end_date = mktime(23,59,59,$EndMonth,$EndDay,$EndYear);
}

$ss_date = "ss.date+'".$config["General"]["timezone_offset"]."'";

$date_condition = "($ss_date>='$start_date' AND $ss_date<='$end_date')";

$smarty->assign("start_date", $start_date);
$smarty->assign("end_date", $end_date);

#
# Collect statistics information
#
$statistics["clients"] = array_pop(func_query_first("select count(login) from $sql_tbl[customers] where usertype='C'"));
$statistics["providers"] = array_pop(func_query_first("select count(login) from $sql_tbl[customers] where usertype='P'"));
$statistics["products"] = array_pop(func_query_first("select count(productid) from $sql_tbl[products]"));
$statistics["categories"] = array_pop(func_query_first("select count(categoryid) from $sql_tbl[categories] where category not like '%/%'"));
$statistics["subcategories"] = array_pop(func_query_first("select count(categoryid) from $sql_tbl[categories] where category like '%/%'"));
$statistics["orders"] = array_pop(func_query_first("select count(orderid) from $sql_tbl[orders]"));

$first_login = "first_login+'".$config["General"]["timezone_offset"]."'";
$add_date = "add_date+'".$config["General"]["timezone_offset"]."'";
$date = "date+'".$config["General"]["timezone_offset"]."'";

$statistics["clients_last_month"] = array_pop(func_query_first("select count(login) from $sql_tbl[customers] where usertype='C' AND ($first_login>='$start_date' AND $first_login<='$end_date')"));
$statistics["providers_last_month"] = array_pop(func_query_first("select count(login) from $sql_tbl[customers] where usertype='P' AND ($first_login>='$start_date' AND $first_login<='$end_date')"));
$statistics["products_last_month"] = array_pop(func_query_first("select count(productid) from $sql_tbl[products] WHERE ($add_date>='$start_date' AND $add_date<='$end_date')"));
$statistics["orders_last_month"] = array_pop(func_query_first("select count(orderid) from $sql_tbl[orders] WHERE ($date>='$start_date' AND $date<='$end_date')"));

	if($active_modules["Advanced_Statistics"])
		include "../modules/Advanced_Statistics/display_stats.php";

#
# Assign Smarty variables and show template
#

$smarty->assign("statistics", $statistics);
$smarty->assign("main", "statistics");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
