<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: config.php,v 1.243.2.4 2003/03/28 13:59:23 svowl Exp $
#
# Global definitions & common functions
#
		
$reg_globals ="0";

if ($reg_globals) {
	if (is_readable("../globals.php"))
		include_once "../globals.php";
	elseif (is_readable("./globals.php"))
		include_once "./globals.php";
}

#
# SQL database details
#
$sql_host ='%SQL_HOST%';
$sql_user ='%SQL_USER%';
$sql_db ='%SQL_DB%';
$sql_password ='%SQL_PASSWORD%';

#
# X-Cart HTTP & HTTPS host
# and web directory where X-Cart installed
#
# NOTE:
# You should put here hostname ONLY without http:// or https:// prefixes
# Do not put slashes after the hostname
# Web dir is the directory in the URL, not the filesystem path
# Web dir must start with slash and have no slash at the end
# The only exception is when you configure for the root of the site,
# in which case you write single slash in it
#
# EXAMPLE 1:
# $xcart_http_host ="www.yourhost.com";
# $xcart_https_host ="www.securedirectories.com/yourhost.com";
# $xcart_web_dir ="/xcart";
# will result in the following URLs:
# http://www.yourhost.com/xcart
# https://www.securedirectories.com/yourhost.com/xcart
#
# EXAMPLE 2:
# $xcart_http_host ="www.yourhost.com";
# $xcart_https_host ="www.yourhost.com";
# $xcart_web_dir ="/";
# will result in the following URLs:
# http://www.yourhost.com/
# https://www.yourhost.com/
#
$xcart_http_host ="$HTTP_HOST";
$xcart_https_host ="$HTTP_HOST";
$xcart_web_dir ="/xcart";

@include "config.local";

#
# SQL tables aliases...
#
$sql_tbl=array(
	"categories" => "xcart_categories",
	"cc_gestpay_data" => "xcart_cc_gestpay_data",
	"cc_pp3_data" => "xcart_cc_pp3_data",
	"ccprocessors" => "xcart_ccprocessors",
	"chprocessors" => "xcart_chprocessors",
	"config" => "xcart_config",
	"countries" => "xcart_countries",
	"country_tax" => "xcart_country_tax",
	"country_zones" => "xcart_country_zones",
	"customers" => "xcart_customers",
	"delivery" => "xcart_delivery",
	"discount_coupons" => "xcart_discount_coupons",
	"discounts" => "xcart_discounts",
	"download_keys" => "xcart_download_keys",
	"extra_fields" => "xcart_extra_fields",
	"featured_products" => "xcart_featured_products",
	"giftcerts" => "xcart_giftcerts",
	"icons" => "xcart_icons",
	"images" => "xcart_images",
	"languages" => "xcart_languages",
	"login_history" => "xcart_login_history",
	"maillist" => "xcart_maillist",
	"modules" => "xcart_modules",
	"newsletter" => "xcart_newsletter",
	"order_details" => "xcart_order_details",
	"orders" => "xcart_orders",
	"partner_banners" => "xcart_partner_banners",
	"partner_clicks" => "xcart_partner_clicks",
	"partner_commitions" => "xcart_partner_commitions",
	"partner_payment" => "xcart_partner_payment",
	"partner_views" => "xcart_partner_views",
	"payment_methods" => "xcart_payment_methods",
	"php_sessions" => "xcart_php_sessions",
	"pricing" => "xcart_pricing",
	"product_bookmarks" => "xcart_product_bookmarks",
	"product_links" => "xcart_product_links",
	"product_options" => "xcart_product_options",
	"product_options_ex" => "xcart_product_options_ex",
	"product_options_js" => "xcart_product_options_js",
	"product_reviews" => "xcart_product_reviews",
	"product_votes" => "xcart_product_votes",
	"products" => "xcart_products",
	"products_lng" => "xcart_products_lng",
	"referers" => "xcart_referers",
	"shipping" => "xcart_shipping",
	"shipping_options" => "xcart_shipping_options",
	"shipping_rates" => "xcart_shipping_rates",
	"state_tax" => "xcart_state_tax",
	"state_zones" => "xcart_state_zones",
	"states" => "xcart_states",
	"stats_cart_funnel" => "xcart_stats_cart_funnel",
	"stats_customers_products" => "xcart_stats_customers_products",
	"stats_pages" => "xcart_stats_pages",
	"stats_pages_paths" => "xcart_stats_pages_paths",
	"stats_pages_views" => "xcart_stats_pages_views",
	"stats_shop" => "xcart_stats_shop",
	"subscription_customers" => "xcart_subscription_customers",
	"subscriptions" => "xcart_subscriptions",
	"tax_rates" => "xcart_tax_rates",
	"thumbnails" => "xcart_thumbnails",
	"wishlist" => "xcart_wishlist",
	"zipcode_tax" => "xcart_zipcode_tax"
);

# Store Credit Cards
# if set to true, X-Cart will store Credit Card numbers in database
# If you want to use Subscription module set it to true
$store_cc = false;

# Store Check Attributes
# if set to true, X-Cart will store Check attributes in database
$store_ch = false;

# Store CVV2 code 
# if set to true, X-Cart will store CVV2 in database
# Please note VISA International does not recommend to store CVV2 code with CC numbers
$store_cvv2 = false;

#
# Which image to show when product has no photo.
#
$default_image = "default_image.gif";
$default_icon = "default_icon.gif";
$default_banner = "default_banner.gif";

#
# Single Store mode (Pro package only)
#
# If you own a Gold package, this value should always be equal to "true".
#
# If $single_mode is set to true the store has shipping
# rates, discounts, taxes and discounts coupons shared between all product
# providers. All product providers can edit each other's products.
# If $single_mode is set to false, each provider has his own
# rates, taxes which applied to on his products only.
#
$single_mode = true;

#
#
# DO NOT CHANGE ANYTHING BELOW THIS LINE UNLESS
# YOU REALLY KNOW WHAT ARE YOU DOING
#
#

#
# Error reporting level:
# default: E_ALL ^ E_NOTICE
#
error_reporting (E_ALL ^ E_NOTICE);
set_magic_quotes_runtime(0);

#
# Demo mode - protects several pages from writing
#
$admin_safe_mode = false;

#
# HTTP & HTTPS locations
#
$http_location = "http://$xcart_http_host".$xcart_web_dir;
$https_location = "https://$xcart_https_host".$xcart_web_dir;

$smarty->assign("http_location",$http_location);
$mail_smarty->assign("http_location",$http_location);
$smarty->assign("https_location",$https_location);
$mail_smarty->assign("https_location",$https_location);

#
# Files directory
#
$files_dir_name = "../files";
$files_http_location = $http_location."/files";

#
# Templates repository
# where original templates are located for "restore" facility
#
$templates_repository = "../skin1_original";

#
# Store sessions data in database
#
$store_sessions_in_mysql = true;

#
# Skin configuration file.
# Configuration files are located under ./configs directory
#
$smarty->assign("skin_config","skin1.conf");
$mail_smarty->assign("skin_config","skin1.conf");

#
# Defined Titles
#
$name_titles = array("Mr.","Mrs.","Ms.");
$smarty->assign("name_titles",$name_titles);

#
# Defined Tax rules (NOT USED)
# tax_type =
# {"disabled", "all","national","international","in our state","out of our state"}
#
# $tax_names = array(
# array("name"=>"VAT", "type"=>"national"),
# array("name"=>"PST", "type"=>"disabled"),
# array("name"=>"GST", "type"=>"disabled")
# );
#
# $smarty->assign("tax_names",$tax_names);
#


#
# Anonimous user name
#
$anonymous_username_prefix="anonymous";

#
# Anonymous user password
#
$anonymous_password="42a51f1538a39636879414b681dd7df6";

#
# SALT & CODE for user password & credit card encryption
#
$CRYPT_SALT = 85; # any number ranging 1-255
$START_CHAR_CODE = 100; # 'd' letter

#
# Include functions
#
if (!@include_once("../include/func.php"))
	@include_once("./include/func.php");

#
# Connect to database
#

db_connect($sql_host, $sql_user, $sql_password);
db_select_db($sql_db) || die("Could not connect to SQL db");


#
# Read config variables from Database
# This variables are used iside php scripts, not in smarty templates
#
$c_result = db_query("select name, value, category from $sql_tbl[config]");
while ($row = db_fetch_row($c_result)) {
        #${$row[0]} = $row[1];
		if(!empty($row[2]))
			$config[$row[2]][$row[0]] = $row[1];
		else
			$config[$row[0]] = $row[1];
}
db_free_result($c_result);

#
# Timezone offset (sec) = N hours x 60 minutes x 60 seconds
#
$config["General"]["timezone_offset"] = intval($config["General"]["timezone_offset"])*3600;

#
# End year for templates where date selectors is there are
#
$config["Company"]["end_year"] = date("Y", time()+$config["General"]["timezone_offset"]) + 1;

#
# Assign config array to smarty
#
$smarty->assign("config",$config);
$mail_smarty->assign("config",$config);

#
# Including file for storing of PHP-sessions in MySQL database
#
if ($store_sessions_in_mysql)
    if (!@include_once("../include/mysql_sessions.php"))
        @include_once("./include/mysql_sessions.php");

#
# Prepare session
#
if (!@include_once("../include/sessions.php"))
	@include_once("./include/sessions.php");
	
#
# Unserialize & Assign memberships levels
#
if ($config["membership_levels"])
	$config["membership_levels"] = unserialize ($config["membership_levels"]);
$smarty->assign ("membership_levels", $config["membership_levels"]);

#
# Unserialize & Assign card types
#
if ($config["card_types"])
	$config["card_types"] = unserialize ($config["card_types"]);
$smarty->assign ("card_types", $config["card_types"]);

#
# Include webmaster mode
#
if (!@include_once("../include/webmaster.php"))
	@include_once("./include/webmaster.php");

if($config["General"]["enable_debug_console"]=="Y" || $editor_mode=='editor')
	$smarty->debugging=true;

#
# Read Modules and put in into $active_modules
#
$all_active_modules=func_query("select * from $sql_tbl[modules] where active='Y'");
if($all_active_modules){
	foreach($all_active_modules as $active_module)
		$active_modules[$active_module["module_name"]]=true;
}		

$active_modules["Simple_Mode"]=true;

unset($all_active_modules);

$smarty->assign("active_modules",$active_modules);
$mail_smarty->assign("active_modules",$active_modules);

#
# WARNING :
# Please ensure that you have no whitespaces / empty lines below this message.
# Adding a whitespace or an empty line below this line will cause a PHP error.
#
?>
