<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: atracking.php,v 1.4.2.1 2003/01/22 07:33:54 svowl Exp $
#
# This script gets advanced tracking info
#

session_register("stats_pageid");
session_register("stats_page_time");
session_register("stats_pages_string");

# Session variables for cart funnel statistics
session_register("stats_transactionid");
session_register("stats_transaction_step");
session_register("cart");

function update_statistics()
{
    global $stats_pageid, $stats_page_time, $stats_pages_string, $REQUEST_URI, $PHP_SELF, $QUERY_STRING, $sql_tbl;

    $old_stats_pageid = $stats_pageid;
    $curtime = time();

    if ($stats_pageid && $stats_page_time) {
#
# Update statistics of previous page views and average time user spent on that page
#
        $time_avg = $curtime - $stats_page_time;
        db_query("UPDATE $sql_tbl[stats_pages_views] SET time_avg='$time_avg' WHERE pageid='$stats_pageid'");

    }

    $stats_page_time = $curtime;

#
# Insert/update statistics of current page views
#

    if(eregi("\/payment\/",$PHP_SELF)) return;
    if (eregi("cart\.php",$PHP_SELF) &&  eregi("mode=wishlist",$QUERY_STRING))
        $page = $PHP_SELF."?mode=wishlist";
    elseif (eregi("cart\.php",$PHP_SELF))
        $page = $PHP_SELF;
    else
        $page = $REQUEST_URI;
        
    $page = ereg_replace("^(.+)([?&]+)(XCARTSESSID=)([0-9a-hA-H]+)([&]*)(.*)$", "\\1\\5\\6", $page);
    $stats_pageid = "";

    $stats_pageid = array_pop(func_query_first("SELECT pageid FROM $sql_tbl[stats_pages] WHERE page='$page'"));


    if (empty($stats_pageid)) {
		db_query("INSERT INTO $sql_tbl[stats_pages](page) VALUES('$page')");
	    $stats_pageid = db_insert_id();
	}
    db_query("INSERT INTO $sql_tbl[stats_pages_views](pageid, date) VALUES('$stats_pageid','$curtime')");

#
# Insert/update statistics of current pages path views
#
    if ($old_stats_pageid == $stats_pageid) return; # if reload - return
    
    if ($stats_pages_string)
        $stats_pages_string .= "-".$stats_pageid;
    else
        $stats_pages_string = $stats_pageid;

    $paths = split("-", $stats_pages_string);

	if (is_array($paths)) {
#
# Maximum length of the pages path
#
		$max_len_path = 5;
	
		$offset = (count($paths)<=$max_len_path)?0:count($paths)-$max_len_path;
	
		$paths = array_slice($paths, $offset);
	}
	
    $string = "";
    for($i = count($paths)-1; $i >= 0 ; $i--) {
        if ($string)
            $string = $paths[$i]."-".$string;
        else
            $string = $paths[$i];


		if (ereg("\-", $string)) {

            db_query("INSERT INTO $sql_tbl[stats_pages_paths] VALUES('$string','$curtime')");
		}

    }

} # function end


#
# Get statistics about shopping cart funnel
#
function update_statistics_cart_funnel()
{
    global $stats_transactionid, $stats_transaction_step, $cart;
    global $mode, $paymentid, $login, $sql_tbl;
    
    if (empty($mode))
        $stats_field = "start_page";
    elseif($mode=="checkout" && $login=="" && !func_is_cart_empty($cart))
        $stats_field = "step1";
    elseif($mode=="checkout" && $paymentid!="" && !func_is_cart_empty($cart))
        $stats_field = "step3";
    elseif($mode=="checkout" && !func_is_cart_empty($cart))
        $stats_field = "step2";
    elseif ($mode=="order_message")
        $stats_field = "final_page";
    else
        return "";

    if ($stats_transaction_step == $stats_field) return "";
    $stats_transaction_step = $stats_field;
    
    if ($stats_transactionid == "" && ($stats_field == "start_page" || $stats_field == "step1" || $stats_field == "step2")) {
        db_query("INSERT INTO $sql_tbl[stats_cart_funnel](login,$stats_field,date) VALUES('$login','1','".time()."')");
        $stats_transactionid = db_insert_id();
        return "$stats_transactionid: $stats_field (create transaction)";
    }
    
    $stats_field_value = array_pop(func_query_first("SELECT $stats_field FROM $sql_tbl[stats_cart_funnel] WHERE transactionid='$stats_transactionid'"));
    $stats_field_value++;
    if ($stats_transactionid && ($stats_field == "step1" || $stats_field == "step2" || $stats_field == "step3" || $stats_field == "final_page"))
        db_query("UPDATE $sql_tbl[stats_cart_funnel] SET $stats_field='$stats_field_value' WHERE transactionid='$stats_transactionid'");

    $trid = $stats_transactionid;
    
    if($stats_field == "final_page")
        $stats_transactionid = "";
        
    return "$trid: $stats_field ($stats_field_value)";

} # function end


update_statistics();

if (eregi("cart\.php",$PHP_SELF)) {

    $stats_cart_funnel = update_statistics_cart_funnel();

}
elseif(!eregi("\/payment\/",$PHP_SELF))
    $stats_transactionid = "";

?>
