<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE Ruslan R. Fazliev TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE Ruslan R. Fazliev TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: webmaster.php,v 1.2.2.2 2003/01/30 12:49:15 ndv Exp $
#
# "Webmaster" mode initialization script 
#

if ($HTTP_POST_VARS["editor_mode"] || $HTTP_GET_VARS["editor_mode"] || $HTTP_COOKIE_VARS["editor_mode"]) {
    header("Location: ../customer/error_message.php?access_denied");
    exit();
}

session_register('editor_mode');
$smarty->webmaster_mode = $HTTP_SESSION_VARS['editor_mode']=='editor';
$smarty->assign("webmaster_mode", $editor_mode);

if (strpos($HTTP_USER_AGENT,'MSIE')!==false) {
	$smarty->assign("user_agent", $user_agent="ie");
} else if (strpos($HTTP_USER_AGENT, 'Netscape')!==false) {
	$smarty->assign("user_agent", $user_agent="ns");
}
# check if in "webmaster" mode
if ($smarty->webmaster_mode) {
	// templates to enclose in <span> and <tbody> tags
	$smarty->tagsTemplates = array(
		"buttons/.*" => span, "currency\.tpl" => span, "product_thumbnail\.tpl" => span, "customer/main/alter_currency_value\.tpl" => span,"modules/Product_Options/customer_options\.tpl" => span, "modules/Subscriptions/subscriptions_menu\.tpl" => span,"modules/Gift_Certificates/gc_admin_menu\.tpl" => span,
	// templates to enclose in <tbody> tags - enumerate the templates consisting
	// of separate table rows (<tr>)
	"modules/Product_Options/customer_options\.tpl" => tbody,
	"modules/Extra_Fields/product\.tpl" => tbody,
	"admin/main/membership_signup\.tpl" => tbody);
	// the rest templates use <div> tag
	
	// remove spans inside tags. Example:
	// <input value="<span>label-text</span>"> -> <input value="label-text">
	//
	$smarty->register_outputfilter("func_remove_span_inside_tags");

	function func_remove_span_inside_tags($text, &$smarty) {
		return eregi_replace("(<[^>]*)(<span[^>]*>)([^<]*)(</span>)", '\1\3', $text);
	}
}

#
# Used from get_languages to convert "lng" smarty variable.
# Replaces each variable "value" with "<span ...>value</span>"
# except some listed in "if" statement (see below). Add variables
# which could appear in javascript code into this "if".
#
function func_webmaster_convert_labels (&$lang) {
	global $user_agent;
	if (is_array($lang)) {
		foreach ($lang as $name=>$val) {
			// check for exceptions
			if ($name!='txt_site_title' && !eregi('txt_subtitle.*', $name) && $name!='txt_cc_number_invalid' && $name!='txt_email_invalid' && $name!='txt_recipient_invalid' && $name!='txt_amount_invalid'  && $name!='txt_gc_enter_mail_address') {
				if ($user_agent=='ie') {
					$lang[$name] = "<span name='$name' onMouseOver=\"lmo('$name')\" onMouseOut=\"lmu('$name')\" onClick=\"lmc('$name')\">$val</span>";
				} else if ($user_agent=='ns'){
					$lang[$name] = "<span name='$name' onMouseOver=\"lmo('$name', event)\" onMouseOut=\"lmu('$name', event)\" onClick=\"lmc('$name', event)\">$val</span>";
				}
			}
		}
	}
}

?>
