<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 RRF.ru development. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The RRF.RU DEVELOPMENT forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE RRF.RU DEVELOPMENT TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE RRF.RU DEVELOPMENT TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is RRF.ru development.           |
| Portions created by RRF.ru development are Copyright (C) 2001-2002          |
| RRF.ru development. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: subscription.php,v 1.4 2002/12/05 13:10:39 alfiya Exp $
#

$subscription_periods = array("Annually"=>"365","Monthly"=>"30", "Weekly"=>"7", "By Period"=>"45");

$subscription = array();

function SubscriptionProducts($products) {

global $subscription_periods, $subscription, $pay_period;
global $sql_tbl;

for($i = 0; $i < count($products); $i++) {

$subscription=func_query_first("select * from $sql_tbl[subscriptions] where productid='".$products[$i][productid]."'");

if ($subscription) {

    if (is_numeric($subscription[pay_period_type])) {
        $pay_period = $subscription[pay_period_type];
        $subscription[pay_period_type] = "By Period";
    }   

    if ($subscription[pay_period_type] == "Annually") {
        $days_in_year = (checkdate(2,29,date("Y"))?366:365);
        if (date("z") >= $subscription[days_as_period])
            $subscription[days_remain] = 0;
        else
            $subscription[days_remain] = $days_in_year - date("z");
    } 
    elseif ($subscription[pay_period_type] == "Quarterly") {
        if (date("m") >= 10) {
            $days_max = date("z",mktime(0,0,0,12,31,date("Y")));
        } elseif (date("m") >= 7) {
            $days_max = date("z",mktime(0,0,0,9,30,date("Y")));
        } elseif (date("m") >= 4) {
            $days_max = date("z",mktime(0,0,0,6,30,date("Y")));
        } else {
            $days_max = date("z",mktime(0,0,0,3,31,date("Y")));
        }
        $cday = $days_max - date("z");

        if ($cday >= $subscription[days_as_period])
            $subscription[days_remain] = 0;
        else
            $subscription[days_remain] = $cday;
    }
    elseif ($subscription[pay_period_type] == "Monthly") {
        if (checkdate(date("m"),31,date("Y")))
            $days_in_month = 31;
        elseif (checkdate(date("m"),30,date("Y")))
            $days_in_month = 30;
        elseif (checkdate(date("m"),29,date("Y")))
            $days_in_month = 29;
        else
            $days_in_month = 28;
        if (date("j") >= $subscription[days_as_period])
            $subscription[days_remain] = 0;
        else
            $subscription[days_remain] = $days_in_month - date("j");
    }
    elseif ($subscription[pay_period_type] == "Weekly") {
        $days_in_week = 7;
        if (date("w") >= $subscription[days_as_period])
            $subscription[days_remain] = 0;
        else
            $subscription[days_remain] = $days_in_week - date("w");
    }
    elseif ($subscription[pay_period_type] == "By Period") {
        $subscription[days_remain] = $pay_period;    #    ˮ ŵ
    }

    $products[$i][catalogprice] = $products[$i][price];
    $products[$i][price] = $products[$i][catalogprice] + $subscription[oneday_price] * $subscription[days_remain];

    if ($products[$i][total])
        $products[$i][total] = $products[$i][price] * $products[$i][amount];
    
    $products[$i][sub_days_remain] = $subscription[days_remain];
    $products[$i][sub_onedayprice] = $subscription[oneday_price];
    $products[$i][sub_plan] = $subscription[pay_period_type];
    $products[$i][sub_priceplan] = $subscription[price_period];
}   #if

} #for

return $products;

} # function

$products = SubscriptionProducts($products);
$f_products = SubscriptionProducts($f_products);

$smarty->assign("pay_period", $pay_period);
$smarty->assign("subscription", $subscription);
?>
