#!/usr/bin/perl

#
# $Id: authorize_net.pl,v 1.11.2.1 2003/02/13 14:06:53 sdg Exp $
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));
#use MD5;

$host="secure.authorize.net";
$script="/gateway/transact.dll";
$port="443";

if (($#ARGV+1)==0) 
{
 print <<EOF;
 Usage: cprocess.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
     -cvv2enabled   +/-   CVV2 enabled/disabled (y/n)
     -cvv2          +/-   Required only when cvv2enabled
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -login         +     Merchant's login on Authorize.NET
     -password      -     Merchant's password on Authorize.NET
     -adcsecur      -     ADC security code on Authorize.NET
                          (temporary unavailable)
     -referer       +     Merchant's host
 ---- Client's info ---
     Parameter  Required  Description
     ---------  --------  -----------
     -firstname     -     Client's firstname
     -lastname      -     Client's lastname
     -address       -     Client's address
     -state         -     Client's state
     -country       -     Client's country
     -zip           -     Client's ZIP-code
     -city          -     Client's city
     -phone         -     Client's phone
 ---- Action's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -action        +     Action
      where:
       -action=auth_only - Authorize only. No processing.
       -action=process   - Process card.
     -mode          +     Processing mode
      where:
       -mode=test         Test mode.
       -mode=real         Real mode.
    -trid                 transaction ID
EOF
exit;
}
foreach $item (@ARGV)
{
 $key="";
 $val="";
 ($key,$val)=split('=',$item);
 if ($key ne "")
 {
  $val=~ s/\"//; 
  $arg{$key}=$val;
 }
}
### --- Check for required parameters
if ($arg{'-action'} eq "auth_only") 
{ 
 $T_Type="auth_only";
}
else 
{ 
 if ($arg{'-action'} eq "process")
 {
  $T_Type="auth_capture";
 }
 else
 {
  print "2,Invalid '-action' parameter";
  exit; 
 }
}

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
 print "2,Invalid '-ccnum' value";
 exit;
}
else
{
 $CC_Num=$arg{'-ccnum'};
}
if ($arg{'-cvv2enabled'} eq "")
{
	print "2,Invalid '-cvv2enabled' value";
	exit;
}

if ($arg{'-cvv2enabled'} eq "y")
{
	if ($arg{'-cvv2'} eq "")
	{
		print "2,Invalid '-cvv2' value";
		exit;
	}
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "" or length($arg{'-ccexpdate'})!=4)
{
 print "2,Invalid '-ccexpdate' value";
 exit;
}
else
{
 $Exp_Date=$arg{'-ccexpdate'};
} 

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
 print "2,Invalid '-ccamount' value";
 exit;
}
else
{
 $amount=$arg{'-ccamount'};
}

if ($arg{'-referer'} eq "")
{
 print "2,Invalid '-referer' value";
 exit;
}
else
{
 $referer=$arg{'-referer'};
}
 

if ($arg{'-login'} eq "")
{
 print "2,Invalid '-login' value";
 exit;
}
else 
{
 $login=$arg{'-login'};
}
if ($arg{'-password'} eq "")
{
 print "2,Invalid '-password' value";
 exit;
}
else
{
 $Password=$arg{'-password'};
 #print $Password;
}

if ($arg{'-mode'} eq "test")
{
 $Test="TRUE";
}
else
{
 if ($arg{'-mode'} eq "real")
 {
  $Test="FALSE"; 
 }
 else
 {
  print "Invalid '-test' value";
  exit;
 }
}

##------------------------------------------------------------------

if ($arg{'-cvv2enabled'} eq "n")
{
	($page, $response, %reply_headers)=post_https($host, $port, $script,
		make_headers(
			'User-Agent' => 'X-Cart',
			'Referer' => $referer 
		),
		make_form (
 		'x_ADC_Delim_Character' => ",",
		'x_ADC_Delim_Data' => "true",
		'x_ADC_URL' => "false",
		'x_Login' => $login,
		'x_Password' => $arg{'-password'},
		'x_Amount' => $amount,
		'x_Method' => 'CC',
		'x_Type' => $T_Type,
		'x_Card_Num' => $CC_Num,
		'x_Exp_Date' => $Exp_Date,
		'x_Test_Request' => $Test,
		'x_Address' => $arg{'-address'},
		'x_City' => $arg{'-city'},
		'x_Country' => $arg{'-country'},
		'x_First_Name' => $arg{'-firstname'},
		'x_Last_Name' => $arg{'-lastname'},
		'x_State' => $arg{'-state'},
		'x_Zip' => $arg{'-zip'},
		'x_Phone' => $arg{'-phone'},
		'x_Email' => $arg{'-email'},
		'x_Version' => '3.0'
	));
}
else
{
	($page, $response, %reply_headers)=post_https($host, $port, $script,
        make_headers(
            'User-Agent' => 'X-Cart',
            'Referer' => $referer
        ),
        make_form (
        'x_ADC_Delim_Character' => ",",
        'x_ADC_Delim_Data' => "true",
        'x_ADC_URL' => "false",
        'x_Login' => $login,
        'x_Password' => $arg{'-password'},
        'x_Amount' => $amount,
        'x_Method' => 'CC',
        'x_Type' => $T_Type,
        'x_Card_Num' => $CC_Num,
        'x_Exp_Date' => $Exp_Date,
        'x_Test_Request' => $Test,
        'x_Address' => $arg{'-address'},
        'x_City' => $arg{'-city'},
        'x_Country' => $arg{'-country'},
        'x_First_Name' => $arg{'-firstname'},
        'x_Last_Name' => $arg{'-lastname'},
        'x_State' => $arg{'-state'},
        'x_Zip' => $arg{'-zip'},
        'x_Phone' => $arg{'-phone'},
        'x_Email' => $arg{'-email'},
        'x_Trans_ID' => $arg{'-trid'},
        'x_Version' => '3.1',
        'x_Card_Code' => $arg{'-cvv2'}
    ));
}

@resp=split(",", $page);
for ($i=0;$i<$#resp;$i++)
{
	$resp[$i]=~ s/\"//g;  
} 

#print "CVV2 response:".$resp[38];
if ($arg{'-action'} eq "auth_only")
{
	if (($arg{"-cvv2enabled"} eq "y" && $resp[38] eq "M") || $arg{"-cvv2enabled"} eq "n")
	{
		if ($resp[0]==1)
		{
			print "1,$resp[5],$resp[6]";
			exit;
		} 
		if ($resp[0]==3 or $resp[0]==2)
		{
			print "2,$resp[3]";
			exit;
		}
		else 
#		if ($resp[0]=~ /invalid/i)
		{
			print "2,$resp[0]";
			exit;
		}
	}
	if ($arg{"-cvv2enabled"} eq "y" && $resp[38] ne "M")
	{
		if ($resp[38] eq "N")
		{
			$reason = "CVV2 code doesn't match";
		}
		if ($resp[38] eq "P")
		{
			$reason = "CVV2 code not processed";
		}
		if ($resp[38] eq "S")
		{
			$reason = "CVV2 code should be present";
		}
		if ($resp[38] eq "U")
		{
			$reason = "Issuer unable to process request";
		}
		print "2,$reason";
	}
}
if ($arg{'-action'} eq "process")
{
	if ($resp[0]==1) {print "1,$resp[3]"; exit;}
	if ($resp[0]==2 or $resp[0]==3 ) {print "2,$resp[3]"; exit;}
	if ($resp[0]=~ /invalid/i) { print "2,$resp[0]";}
}
