#!/usr/bin/perl

#
# $Id: blue.pl,v 1.4 2002/12/10 08:57:10 sdg Exp $
#

#
# Mirror from Plug n Pay script
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));

$host="bluepay.onlinedatacorp.com";$port="443";

if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: blue.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
	 -ccvv2         -     CVV2 code
     -bname1        +     First Name
     -bname2        +     Last Name
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
	 -phone         -     User Phone
	 -email         -     User Email
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
	 -order         +     OrderID
     -login         +     Merchant's username 
	 -type          +     Charge mode: AUTH | SALE
	 -test          +     Test mode  : test | live
	 -referer       +     Referer URL (ex.: http://www.vasia.com)
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters

if($arg{'-test'} eq "live")
{ $script = "/prod/bluepaylite.asp"; }
else
{ $script = "/test/bluepaylitetest.asp"; }

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname1'} eq "")
{
	print "2,Invalid '-bname1' value, i.e. first name";
	exit;
}

if ($arg{'-bname2'} eq "")
{
	print "2,Invalid '-bname2' value, i.e. last name";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if (($arg{'-type'} eq "")&&($arg{'-type'} ne "AUTH")&&($arg{'-type'} ne "SALE"))
{
	print "2,Invalid '-type' value";
	exit;
}

if ($arg{'-login'} eq "")
{
	print "2,Invalid '-login' value";
	exit;
}

if ($arg{'-referer'} eq "")
{
	print "2,Invalid '-referer' value";
	exit;
}

if ($arg{'-order'} eq "")
{
	print "2,Invalid '-order' value";
	exit;
}

##------------------------------------------------------------------
$expmo=substr($arg{'-ccexpdate'},0,2);
$expye=substr($arg{'-ccexpdate'},2,2);

$header=make_headers(
"User-Agent" => "BLUEPAYAPI_pl\\1.1 X-Cart",
"Referer" => $arg{'-referer'}
);

$form= make_form (
 'MERCHANT' => $arg{'-login'},
 'TRANSACTION_TYPE' => $arg{'-type'},
 'CC_NUM' => $arg{'-ccnum'},
 'CC_Expires' => $expmo."/".$expye,
 'AMOUNT' => $arg{'-ccamount'},
 'NAME' => $arg{'-bname1'}." ".$arg{'-bname2'},
 'Addr1' => $arg{'-baddr'},
 'Addr2' => "",
 'CITY' => $arg{'-bcity'},
 'STATE' => $arg{'-bstate'},
 'ZIPCODE' => $arg{'-bzip'},
 'Order_ID' => $arg{'-order'},
 'COMMENT' => "",
 'PHONE' => $arg{'-phone'},
 'EMAIL' => $arg{'-email'},
 'CVCCVV2' => $arg{'-ccvv2'}
);

($page, $response, %reply_headers)=post_https($host, $port, $script, $header, $form);

if($page =~ /\?Result=MISSING/i)
	{ $isSuccess=0;$isError="Missing";}
if($page =~ /\?Result=DECLINED/i)
	{ $isSuccess=0;$isError="Declined";}
if($page =~ /\?Result=APPROVED/i)
	{ $isSuccess=1;$isError="Approved";}

if(!length($page))
	{ $isSuccess=0; $isError="Failed. Operation timed out."; }
if($isError eq "")
	{ $isSuccess=0; $isError="Failed. Unknown error."; }


print $isSuccess?1:2; print ",".$isError;
