#!/usr/bin/perl

#
# $Id: ccash.pl,v 1.2 2002/12/10 08:57:10 sdg Exp $
#

#
# Mirror from Plug n Pay script
#

BEGIN
{
# !!! IMPORTANT !!!
# Path to mck-cgi dir. For example: /mystore/merchantid/mck-cgi
$path2mck = "/u/sdg/www/soccerstorecom5-64/mck-cgi";
push(@INC,$path2mck);
}

# MCK function
use CCMckLib3_2 qw(InitConfig);
use CCMckDirectLib3_2 qw(SendCC2_1Server doDirectPayment);
use CCMerchantTest qw($ConfigFile);
use CCMerchantCustom qw(GenerateOrderId);


if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: ccash.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
	 -order         +     OrderID
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
     -bname1        +     First Name
     -bname2        +     Last Name
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -type          +     Charge type (A)uth/(AC)uth&Capture = N/Y
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname1'} eq "")
{
	print "2,Invalid '-bname1' value, i.e. first name";
	exit;
}

if ($arg{'-bname2'} eq "")
{
	print "2,Invalid '-bname2' value, i.e. last name";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if (($arg{'-type'} eq "")&&($arg{'-type'} ne "A")&&($arg{'-type'} ne "AC"))
{
	print "2,Invalid '-type' value";
	exit;
}

if ($arg{'-type'} eq "")
{
	print "2,Invalid '-type' value";
	exit;
}

if ($arg{'-order'} eq "")
{
	print "2,Invalid '-order' value";
	exit;
}

##------------------------------------------------------------------

$status= &InitConfig ($ConfigFile);
if ($status != 0)
{ print "2, unable to initialize configuration";
}

$args{'order-id'}    = $arg{'-order'},
$args{'amount'}      = "usd ".$arg{'-ccamount'};
$args{'card-number'} = $arg{'-ccnum'};
$args{'card-exp'}    = substr($arg{'-ccexpdate'},0,2)."/".substr($arg{'-ccexpdate'},2,2);
$args{'card-name'}   = $arg{'-bname1'}." ".$arg{'-bname2'};
$args{'card-address'}= $arg{'-baddr'};
$args{'card-city'}   = $arg{'-bcity'};
$args{'card-zip'}    = $arg{'-bzip'};
$args{'card-state'}  = $arg{'-bstate'};
$args{'card-country'}= $arg{'-bcountry'};

#foreach (keys (%args))
#{ print (" $_ -> $args{$_}\n"); }
#print "TYPE: ".(($arg{'-type'} ne 'Y')?('mauthonly'):('mauthcapture'));
# send the message to the CashRegister to authorize
# and capture a card transaction
%result = &SendCC2_1Server ((($arg{'-type'} ne 'Y')?('mauthonly'):('mauthcapture')), %args);

# print all the name-value pairs returned by the message
#foreach (keys (%result))
#{ print (" $_ -> $result{$_}\n"); }

# print an error message if transaction didn't succeed
if (($result {'MStatus'} ne "success") && ($result {'MStatus'} ne "success-duplicate"))
{ print "2,".$result{'MErrMsg'}; }
else
{ print "1,Accepted";}
