#!/usr/bin/perl

#
# $Id: efsnet.pl,v 1.3 2002/12/10 08:57:10 sdg Exp $
#

#
# Mirror from Plug n Pay script
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));

$script="/efsnet.dll";
$port="443";


if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: eway.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
	 -cvv2          -     CVV2 Code
     -bname         +     Name as it appear on Credit Card
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        -     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
	 -phone         -     Customer's Phone
	 -email         -     Customer's Email
	 -order         +     OrderID
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -StoreID       +     StoreID
     -StoreKey      +     StoreKey
	 -test          +     Test: TRUE or FALSE
	 -req           +     C (CreditCardCharge) or A (CreditCardAuthorize)
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters
if ($arg{'-test'} eq "FALSE")
{	$host="efsnet.concordebiz.com"; }
else
{	$host="testefsnet.concordebiz.com"; }

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname'} eq "")
{
	print "2,Invalid '-bname' value";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if ($arg{'-bcountry'} eq "")
{
	print "2,Invalid '-bcountry' value";
	exit;
}

if ($arg{'-bcity'} eq "")
{
	print "2,Invalid '-bcity' value";
	exit;
}

if ($arg{'-email'} eq "")
{
	print "2,Invalid '-email' value";
	exit;
}

if ($arg{'-StoreID'} eq "")
{
	print "2,Invalid '-StoreID' value";
	exit;
}

if ($arg{'-StoreKey'} eq "")
{
	print "2,Invalid '-StoreKey' value";
	exit;
}

if (($arg{'-req'} eq "")&&($arg{'-req'} ne "A")&&($arg{'-req'} ne "C"))
{
	print "2,Invalid '-req' value (A)utorize or (C)harge Method";
	exit;
}
else
{
	$method=($arg{'-req'} eq "C")?("CreditCardCharge"):("CreditCardAuthorize");
}

if ($arg{'-order'} eq "")
{
    print "2,Invalid '-order' value";
    exit;
}

##------------------------------------------------------------------

@n=split(" ",$arg{'-bname'});
$lastname=substr(pop(@n),0,7);

($page, $response, %reply_headers)=post_https($host, $port, $script,
 make_headers(
  'User-Agent' => 'X-Cart'
 ),
make_form(
'Method' => $method,
'StoreID' => $arg{'-StoreID'},
'StoreKey' => $arg{'-StoreKey'},
'ApplicationID' => 'Xcart EFSNet payment module',
'TransactionAmount' => $arg{'-ccamount'},
'AccountNumber' => $arg{'-ccnum'},
'ReferenceNumber' => $arg{'-order'},
'ExpirationMonth' => substr($arg{'-ccexpdate'},0,2),
'ExpirationYear' => substr($arg{'-ccexpdate'},2,2),
'CardVerificationValue' => $arg{'-cvv2'},
'BillingName' => $arg{'-bname'},
'BillingAddress' => $arg{'-baddr'},
'BillingCity' => $arg{'-bcity'},
'BillingState' => $arg{'-bstate'},
'BillingPostalCode' => $arg{'-bzip'},
'BillingCountry' => $arg{'-bcountry'},
'BillingPhone' => $arg{'-phone'},
'BillingEmail' => $arg{'-email'})
);

@pairs=split("&",$page);
foreach (@pairs)
{ ($a,$b)=split("=");
  $respcode=$b if($a eq "ResponseCode");
  $message=$b if($a eq "ResultMessage");
}

%error=(
"1" => "Transaction previously approved",
"128" => "Authentication required",
"256" => "Transaction declined",
"257" => "Insufficient funds",
"258" => "Invalid card number, MICR numberor routing number",
"259" => "Card expired",
"260" => "Contact financial institution",
"261" => "Authentication failed",
"262" => "Unable to authenticate",
"1023" => "Generic processor error",
"1024" => "General error",
"1026" => "Communications error, try again",
"1027" => "Communications failure",
"1028" => "Duplicate ReferenceNumber",
"1029" => "Invalid merchant",
"1030" => "Invalid request",
"1031" => "Invalid StoreID",
"1032" => "Invalid StoreKey",
"1033" => "Invalid processor",
"1034" => "Invalid transaction",
"1035" => "Transaction not permitted",
"1036" => "A query is already in progress",
"8191" => "Unknown error",
);
print ((!$respcode)?("1, Transaction approved"):("2,".$error{$respcode}));
