#!/usr/bin/perl

#
# $Id: eway.pl,v 1.2 2002/12/10 08:57:11 sdg Exp $
#

#
# Mirror from Plug n Pay script
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));

$host="www.eway.com.au";
$port="443";


if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: eway.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
     -bname         +     Name as it appear on Credit Card
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
	 -order         +     OrderID
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -login         +     Merchant's username 
     -partner       +     Merchant's partner
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters
if ($arg{'-test'} eq "FALSE")
{	$script="/gateway/xmlpayment.asp"; }
else
{	$script="/gateway/xmltest/TestPage.asp"; }

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname1'} eq "")
{
	print "2,Invalid '-bname1' value, i.e. first name";
	exit;
}

if ($arg{'-bname2'} eq "")
{
	print "2,Invalid '-bname2' value, i.e. last name";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if ($arg{'-email'} eq "")
{
	print "2,Invalid '-email' value";
	exit;
}

if ($arg{'-login'} eq "")
{
	print "2,Invalid '-login' value";
	exit;
}

if ($arg{'-order'} eq "")
{
    print "2,Invalid '-order' value";
    exit;
}


##------------------------------------------------------------------

($page, $response, %reply_headers)=post_https($host, $port, $script,
 make_headers(
  'User-Agent' => 'X-Cart',
  'Content-Type' => 'text/xml'
 ),
 "<ewaygateway>".
 "<ewayCustomerID>".$arg{'-login'}."</ewayCustomerID>".
 "<ewayTotalAmount>".$arg{'-ccamount'}."</ewayTotalAmount>".
 "<ewayCustomerFirstName>".$arg{'-bname1'}."</ewayCustomerFirstName>".
 "<ewayCustomerLastName>".$arg{'-bname2'}."</ewayCustomerLastName>".
 "<ewayCustomerEmail>".$arg{'-email'}."</ewayCustomerEmail>".
 "<ewayCustomerAddress>".$arg{'-baddr'}."</ewayCustomerAddress>".
 "<ewayCustomerPostcode>".$arg{'-bzip'}."</ewayCustomerPostcode>".
 "<ewayCustomerInvoiceDescription>".$arg{'-desc'}."</ewayCustomerInvoiceDescription>".
 "<ewayCustomerInvoiceRef>".$arg{'-order'}."</ewayCustomerInvoiceRef>".
 "<ewayCardHoldersName>".$arg{'-bname1'}." ".$arg{'-bname2'}."</ewayCardHoldersName>".
 "<ewayCardNumber>".$arg{'-ccnum'}."</ewayCardNumber>".
 "<ewayCardExpiryMonth>".substr($arg{'-ccexpdate'},0,2)."</ewayCardExpiryMonth>".
 "<ewayCardExpiryYear>".substr($arg{'-ccexpdate'},2,2)."</ewayCardExpiryYear>".
 "<ewayTrxnNumber></ewayTrxnNumber>".
 "<ewayOption1></ewayOption1>".
 "<ewayOption2></ewayOption2>".
 "<ewayOption3>".(($arg{-test} eq "TRUE")?("TRUE"):(""))."</ewayOption3>".
 "</ewaygateway>"
);


$page =~ /<ewayTrxnStatus>(.*)<\/ewayTrxnStatus>/i;	$isSuccess=($1 =~ /True/i);
$page =~ /<ewayTrxnError>(.*)<\/ewayTrxnError>/i;	$isError=$1;
$page =~ /<ewayAuthCode>(.*)<\/ewayAuthCode>/i;		$isAuth=$1;

print (($isSuccess)?("1,".$isAuth):("2,".$isError));
