#!/usr/bin/perl

#
# $Id: intellipay_com.pl,v 1.2 2002/04/22 17:10:30 mav Exp $
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));

#$Net::SSLeay::trace = 2;

$host="www.intellipay.net";
$script="/LinkSmart/";
$port="443";

if (($#ARGV+1)==0) 
{
 print <<EOF;
 Usage: intellipay_com.pl <parameters> 
 Where parameters is:

 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
     -ctype         +     Card type
     -invoice      +/-    Invoice, requires only if -ctype=VI (Visa)		 

 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -login         +     Merchant's login on Intellipay.com 
     -password      +     Merchant's password on Intellipay.com 

 ---- Client's info ---
     Parameter  Required  Description
     ---------  --------  -----------
     -name          -     Client's name
     -address       -     Client's address
     -state         -     Client's state
     -country       -     Client's country
     -zip           -     Client's ZIP-code
     -city          -     Client's city
EOF
exit;
}
foreach $item (@ARGV)
{
 $key="";
 $val="";
 ($key,$val)=split('=',$item);
 if ($key ne "")
 {
  $val=~ s/\"//; 
  $arg{$key}=$val;
 }
}
#-------------------------------
# -invoice parameter realisation
#-------------------------------
if ($arg{'-ctype'} eq "VI" and $arg{'-invoice'} eq "")
{
 print "2,'-invoice' parameter requires for Visa card";
 exit;
}

#-----------------------------
# -ccnum parameter realisation
#-----------------------------
if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
 print "2,Invalid '-ccnum' value";
 exit;
}
else
{
 $CC_Num=$arg{'-ccnum'};
}
#-----------------------------
# -ctype parameter realisation
#-----------------------------
if ($arg{'-ctype'} eq "")
{
 print "2,Invalid '-ctype' value";
 exit;
}

#---------------------------------
# -ccexpdate parameter realisation
#---------------------------------
if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "" or length($arg{'-ccexpdate'})!=4)
{
 print "2,Invalid '-ccexpdate' value";
 exit;
}
else
{
 $Exp_Date=$arg{'-ccexpdate'};
} 

#--------------------------------
# -ccamount parameter realisation
#--------------------------------
if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
 print "2,Invalid '-ccamount' value";
 exit;
}
else
{
 $amount=$arg{'-ccamount'};
}

#-----------------------------
# -login parameter realisation
#-----------------------------
if ($arg{'-login'} eq "")
{
 print "2,Invalid '-login' value";
 exit;
}
else 
{
 $login=$arg{'-login'};
}

#-------------------------------
# -password parameter relisation
#-------------------------------
if ($arg{'-password'} eq "")
{
 print "2,Invalid '-password' value";
 exit;
}
else
{
 $password=$arg{'-password'};
}

##------------------------------------------------------------------


($page, $response, %reply_headers)=post_https($host, $port, $script,
 make_headers(
  'User-Agent' => 'X-Cart',
	'Referer' => $arg{'-referer'} 
 ),
 make_form (
 'LOGIN' => $login,
 'PASSWORD' => $password,
 'DELIMCHARACTER' => ',',
 'AMOUNT' => $amount,
 'TYPE' => 'NA',
 'METHOD' => $arg{'-ctype'},
 'CARDNUM' => $CC_Num,
 'EXPDATE' => $Exp_Date,
 'ADDRESS' => $arg{'-address'},
 'CITY' => $arg{'-city'},
 'COUNTRY' => $arg{'-country'},
 'NAME' => $arg{'-name'},
 'STATE' => $arg{'-state'},
 'ZIP' => $arg{'-zip'},
 'RECEIPTFORMAT' => 'NamedValueList'
));
$flag=0;
if ($reply_headers{'LOCATION'} ne "")
{
 ($page) = post_https($host, $port, $reply_headers{'LOCATION'},
 make_headers(
           'User-Agent' => 'X-Cart',
					 'COOKIE' => $reply_headers{'SET-COOKIE'}
 ));
 $flag=1;
}
#print $page;
push (@lines, $1) while ($page=~ s/^([^\012\015]*)(\012\015?|\015\012?)//);

foreach $line (@lines)
{
 ($key,$value)=split ('=',$line);
 $responseText{$key}=$value;
}
if ($flag==0)
{
 if ($responseText{'RESPONSECODE'} eq "A")
 {
  print "1,Approved. The purchase has been authorized by the issuer."; 
 }
 if ($responseText{'RESPONSECODE'} eq "S")
 {
  print "2,Declined. A possible duplicate transaction.";
 } 
 if ($responseText{'RESPONSECODE'} eq "D")
 {
  print "2,Declined. The authorizer has declined the purchase request.";
 }
 if ($responseText{'RESPONSECODE'} eq "R")
 {
	  print "2,Referred. The issuer has asked that you call the Voice Authorization center.";
 } 
 if ($responseText{'RESPONSECODE'} eq "X")
 {
   print "2,Expired. The card has expired.";
 }
 if ($responseText{'RESPONSECODE'} eq "E")
 {
  print "2,Error. A data entry error of some kind has occurred.";
 } 
 if ($responseText{'RESPONSECODE'} eq "U")
 { 
   print "2,Unknown. An unknown processor or issuer error has occurred.";
 } 
 if ($responseText{'RESPONSECODE'} eq "F")
 { 
  print "2,Failure. A system failure of some kind has occurred.";
 } 
}
else
{
 print "2,".$responseText{'ERRORMESSAGE'};
}
