<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: payment_giftcert.php,v 1.15 2002/12/18 06:24:23 svowl Exp $
#
# Gift certificate processing payment module
#

require "../include/payment_method.php";

#
# Checking GC if it's already applied to order
#
$gc_applied = false;
if ($cart["applied_giftcerts"]) {
    foreach($cart["applied_giftcerts"] as $k=>$v) {
        if ($v["giftcert_id"] == $gcid) {
            $gc_applied = true;
            break;
        }
    }
}

if ($gc_applied) {
    header("Location: ../customer/cart.php?mode=checkout&err=gc_used&paymentid=14");
    exit;
}

#
# Unblock GC after $config["Modules"]["gc_blocking_period"] minutes of blocking
#
$gc_blocking_period = $config["Modules"]["gc_blocking_period"] * 60;

db_query("UPDATE $sql_tbl[giftcerts] SET status='A' WHERE gcid='$gcid' AND status='B' AND block_date+'$gc_blocking_period'<'".time()."'");

$gc = func_query_first("SELECT * FROM $sql_tbl[giftcerts] WHERE gcid='$gcid' AND status='A' AND debit>'0'");
if (empty($gc))
{
#
# Non existing Gift certificate
#
    header("Location: ../customer/error_message.php?error_giftcert_notfound");
    exit;
}
else {
#
# Gift certificate exists
#
    $cart_["giftcert_id"] = $gcid;
    $cart_["giftcert_cost"] = $gc["debit"];
    $cart["applied_giftcerts"][] = $cart_;

	db_query("UPDATE $sql_tbl[giftcerts] SET status='B', block_date='".time()."' WHERE gcid='$gcid'");
	
	if ($gc["debit"]>=$cart["total_cost"]) {
#
# Process order
#
        $cart["applied_giftcerts"][count($cart["applied_giftcerts"])-1]["giftcert_cost"] = $cart["total_cost"];
        $cart["giftcert_discount"] += $cart["total_cost"];
        $cart["total_cost"] = 0;
        if ($cart["orders"])
            foreach($cart["orders"] as $k=>$v)
                $cart["orders"][$k]["total_cost"] = $cart["total_cost"];

        $orderids = func_place_order($payment_method,"I",$order_details.$ship_to);
		func_change_order_status($orderids,"P");
        $_orderids = func_get_urlencoded_orderids ($orderids);

#
# Remove all from cart
#
        $cart="";
        header("Location: $http_location/customer/cart.php?mode=order_message&orderids=$_orderids");
        exit;
    }
    else {
#
# Not enough money
#
        header("Location: ../customer/cart.php?mode=checkout&paymentid=$paymentid");
        exit;
    }

}
?>
