#!/usr/bin/perl

#
# $Id: processusa_com.pl,v 1.3 2002/09/17 06:11:37 sdg Exp $
#

use Net::SSLeay qw(get_https post_https sslcat make_headers make_form);
#use MD5;

$host = "secure.paymentclearing.com";
$script = "/cgi-bin/rc/ord.cgi";
$port = "443";

#$ret_mode = "post";
#$post_back_on_error = "1";

if (($#ARGV+1)==0) { 
	print <<EOF;
  Usage: processusa_com.pl <parameters> 
  Where parameters is:
  ---- Credit card info ----
      Parameter  Required  Description
      ---------  --------  -----------
      -ccnum         +     Credit card number
      -ccmo          +     Credit card expiration month
      -ccyr          +     Credit card expiration year

  ---- Merchant's info ----
      Parameter  Required  Description
      ---------  --------  -----------
      -vendorid      +     Merchant's ID on processusa.COM 
      -hpage         +     Merchant's home page URL
      -retaddr       +     The full URL to which customers are directed 
                           after order completion.

  ---- Client's info ---
      Parameter  Required  Description
      ---------  --------  -----------
      -firstname     +     Client's firstname
      -lastname      +     Client's lastname
      -address       +     Client's address
      -city          +     Client's city
      -state         +     Client's state
      -zip           +     Client's ZIP-code
      -country       +     Client's country
      -phone         +     Client's phone
      -email         +     Client's e-mail

  ---- Client's shipping address ----
      Parameter  Required  Description
      ---------  --------  -----------
      -sfname        -     Client's firstname
      -slname        -     Client's lastname
      -saddr         -     Client's address
      -scity         -     Client's city
      -sstate        -     Client's state
      -szip          -     Client's ZIP-code
      -sctry         -     Client's country
     
  ---- Item info ----
      !!!SPECIFIED FROM STDIN!!!
      Parameter  Required  Description
      ---------  --------  -----------
      -idescN        +     Description of item number N
      -icostN        +     Cost of item number N
      -iqtyN         +     Quantity of item number N
      
      !!!ALL 3 parameters are required for EACH item!!!
EOF
	exit;
}

foreach $item (@ARGV) {
	$key = "";
	$val = "";
	($key,$val) = split('=',$item);
 
	if ($key ne "") {
		$val =~ s/\"//g; 
		$arg{$key} = $val;
	}
}

### --- Check for required parameters
if (!($arg{'-ccnum'} =~ /^([0-9]{1,20})$/)) {
	print "2,Invalid '-ccnum' value";
  	exit;
} else {
	$CC_Num = $arg{'-ccnum'};
}

if ($arg{'-ccmo'} eq "") {
	print "2,Invalid '-ccmo' value";
	exit;
} else {
	$CC_Mo = $arg{'-ccmo'};
}

if (!($arg{'-ccyr'} =~ /^(2\d{3})$/)) {
        print "2,Invalid '-ccyr' value";
	exit;
} else {
        $CC_Year = $arg{'-ccyr'};
}

if (!($arg{'-vendorid'} =~ /^(\d{1,})$/)) {
	print "2,Invalid '-vendorid' value";
	exit;
} else {
	$Vendor_id = $arg{'-vendorid'};
}

if ($arg{'-hpage'} eq "") {
	print "2,Invalid '-hpage' value";
	exit;
} else {
	$HPage = $arg{'-hpage'};
}

if ($arg{'-retaddr'} eq "") {
        print "2,Invalid '-retaddr' value";
	exit;
} else {
	$RetAddr = $arg{'-retaddr'};
}

# getting items information
$_idesc = "-idesc";
$_icost = "-icost";
$_iqty = "-iqty";
$i = 1;

while (defined ($tmp = <STDIN>)) {
	$tmp =~ s/\n//;
	if ($tmp eq ".") {
		last;
	}
	$arg{$_idesc.$i} = $tmp;

	if (defined ($tmp = <STDIN>)) {
		$tmp =~ s/\n//;
		$arg{$_icost.$i} = $tmp;
	} else {
		print "2,Invalid '-icost$i' value";
		exit;
	}

	if (defined ($tmp = <STDIN>)) {
		$tmp =~ s/\n//;
		$arg{$_iqty.$i} = $tmp;
	} else {
		print "2,Invalid '-iqty$i' value";
		exit;
	}

	$i++;
}
# here we have $i-1 items specified
$max_itm = $i-1;

if ($max_itm == 0) {
	print "2,No items specified";
	exit;
}

# filling array of form's variables
@fdata;

# Merchant's info
$fdata{'vendor_id'} = $Vendor_id;
$fdata{'home_page'} = $HPage;
$fdata{'ret_addr'} = $RetAddr;

# Client's info
$fdata{'first_name'} = $arg{'-firstname'};
$fdata{'last_name'} = $arg{'-lastname'};
$fdata{'address'} = $arg{'-address'};
$fdata{'city'} = $arg{'-city'};
$fdata{'state'} = $arg{'-state'};
$fdata{'zip'} = $arg{'-zip'};
$fdata{'country'} = $arg{'-country'};
$fdata{'phone'} = $arg{'-phone'};
$fdata{'email'} = $arg{'-email'};

# Credit card info
$fdata{'ccnum'} = $CC_Num;
$fdata{'ccmo'} = $CC_Mo;
$fdata{'ccyr'} = $CC_Year;

# Client's shipping info 
# (if specified)
if (!($arg{'-sfname'} eq "")) {

	$fdata{'sfname'} = $arg{'-sfname'};
	$fdata{'slname'} = $arg{'-slname'};
	$fdata{'saddr'} = $arg{'-saddr'};
	$fdata{'scity'} = $arg{'-scity'};
	$fdata{'sstate'} = $arg{'-sstate'};
	$fdata{'szip'} = $arg{'-szip'};
	$fdata{'sctry'} = $arg{'-sctry'};
}

# Items info
for ($i = 1; $i <= $max_itm; $i++) {
	$fdata{$i."_desc"} = $arg{$_idesc.$i};
	$fdata{$i."_cost"} = $arg{$_icost.$i};
	$fdata{$i."_qty"} = $arg{$_iqty.$i};
}

#$fdata{'ret_mode'} = $ret_mode;
#$fdata{'post_back_on_error'} = $post_back_on_error;

# form data array @fdata is now filled

#print "\@fdata content:\n";
#foreach $item (keys (%fdata)) {
#	print "$item = $fdata{$item}\n";
#}

#exit;

# posting form data
($page, $response, %reply_headers) = post_https($host, $port, $script,'',
	make_form(%fdata));
##

@resp = split(' ', $response);
if ($resp[1] =~ /2\d\d/) {
	@pg = split('\n', $page);
	foreach $item (@pg) {
		if ($item =~ /^Code: A\d\d\d/) {
			print "2,$item";
			exit;
		}
	}
	print "1,$resp[2]";
} else {
	print "2,$resp[2]";
}

#foreach $item (keys (%reply_headers))
#{
#	print "$item = $reply_headers{$item}\n";
#}

exit;
