#!/usr/bin/perl

#
# $Id: ptech.pl,v 1.2.2.1 2003/03/13 14:23:21 svowl Exp $
#

#
# Mirror from Plug n Pay script
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));

$host="epayhipvar.paymentech.net";$port="443";
#$host="ipgtst.paymentech.net";$port="3443";
$script="/autorize";


if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: ptech.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
	 -ccvv2         -     CVV2 code
     -bname1        +     First Name
     -bname2        +     Last Name
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
     -order         +     OrderID
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -login         +     Merchant's username 
	 -tz            +     Cart's TimeZone
	 -cur           +     Currency ISO code
	 -type          +     Charge type (A)uth/(AC)uth&Capture
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname1'} eq "")
{
	print "2,Invalid '-bname1' value, i.e. first name";
	exit;
}

if ($arg{'-bname2'} eq "")
{
	print "2,Invalid '-bname2' value, i.e. last name";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if (($arg{'-type'} eq "")&&($arg{'-type'} ne "A")&&($arg{'-type'} ne "AC"))
{
	print "2,Invalid '-type' value";
	exit;
}

if ($arg{'-login'} eq "")
{
	print "2,Invalid '-login' value";
	exit;
}

if ($arg{'-cur'} eq "")
{
	print "2,Invalid '-cur' value";
	exit;
}

if ($arg{'-tz'} eq "")
{
	print "2,Invalid '-tz' value";
	exit;
}

if ($arg{'-order'} eq "")
{
    print "2,Invalid '-order' value";
    exit;
} 

##------------------------------------------------------------------

$TxRefNum=int(rand(8999999999999)+1000000000000).int(rand(8999999999)+1000000000);

$xml=
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>".
"<!DOCTYPE Request SYSTEM \"Request_PTI12.dtd\">".
"<Request>".
"<AC>".
"<CommonData>".
"	<CommonMandatory AuthOverrideInd=\"N\" LangInd=\"00\" CardHolderAttendanceInd=\"01\" HcsTcsInd=\"T\" TxCatg=\"7\" MessageType=\"".$arg{'-type'}."\" Version=\"2\" TzCode=\"".$arg{'-tz'}."\">".
"		<AccountNum AccountTypeInd=\"91\">".$arg{'-ccnum'}."</AccountNum>".
"		<POSDetails POSEntryMode=\"01\"/>".
"		<MerchantID>".$arg{'-login'}."</MerchantID>".
"		<TerminalID TermEntCapInd=\"05\" CATInfoInd=\"06\" TermLocInd=\"01\" CardPresentInd=\"N\" POSConditionCode=\"59\" AttendedTermDataInd=\"01\">001</TerminalID>".
"		<BIN>".((length($arg{'-login'})==6)?("000001"):("000002"))."</BIN>".
"		<OrderID>".$arg{'-order'}."</OrderID>".
"		<AmountDetails><Amount>".((($arg{'-cur'} eq "392")?(1):(100))*$arg{'-ccamount'})."</Amount></AmountDetails>".
"		<TxTypeCommon TxTypeID=\"G\"/>".
"		<Currency CurrencyCode=\"".$arg{'-cur'}."\" CurrencyExponent=\"".(($arg{'-cur'} eq "392")?(0):(2))."\"/>".
"		<CardPresence><CardNP><Exp>".$arg{'-ccexpdate'}."</Exp></CardNP></CardPresence>".
"		<TxDateTime/>".
"	</CommonMandatory>".
"	<CommonOptional>".
"	<CardSecVal>".$arg{'-ccvv2'}."</CardSecVal>".
#(($arg{'-type'} eq "A")?(""):("<TxRefNum>".$TxRefNum."</TxRefNum><TxRefldx/>")).
"	</CommonOptional>".
"</CommonData>".
"<Auth>".
"	<AuthMandatory FormatInd=\"H\"/>".
"	<AuthOptional><AVSextended>".
"		<AVSname>".$arg{'-bname1'}." ".$arg{'-bname2'}."</AVSname>".
"		<AVSaddress1>".$arg{'-baddr'}."</AVSaddress1>".
"		<AVScity>".$arg{'-bcity'}."</AVScity>".
"		<AVSstate>".$arg{'-bstate'}."</AVSstate>".
"		<AVSzip>".$arg{'-bzip'}."</AVSzip>".
"	</AVSextended></AuthOptional>".
"</Auth>".
"<Cap>".
"	<CapMandatory><EntryDataSrc>02</EntryDataSrc></CapMandatory>".
"	<CapOptional/>".
"</Cap>".
"</AC>".
"</Request>";

$header=make_headers(
  'MIME-Version' => '1.0',
#  'Content-length' => length($xml),
  'Content-transfer-encoding' => 'text',
  'Document-type' => 'Request',
  'Request-number' => $TxRefNum
);

($page, $response, %reply_headers)=post_https($host, $port, $script, $header, $xml, "application/PTI12");

#print $xml;
#print $page;
if($page =~ /<ProcStatus>(.*)<\/ProcStatus>/i)
	{ $isSuccess=!$1;}
if($page =~ /<StatusMsg.*>(.*)<\/StatusMsg>/i)
	{ $isError=$1;}
if($page =~ /<RespMsg>(.*)<\/RespMsg>/i)
	{ $isError=$1;}

if(!length($page))
	{ $isSuccess=0; $isError="Failed. Operation timed out."; }

print $isSuccess?1:2; print ",".$isError;
