#!/usr/bin/perl

#
# $Id: secpay.pl,v 1.2 2002/09/17 06:11:37 sdg Exp $
#

#
# Mirror from Plug n Pay script
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));

sub urldecode
{
	local($val2)=@_;
	$val2=~ s/\+/ /g;
	$val2=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C',hex($1))/ge;
	return $val2;
}


$host="www.secpay.com";
$script="/java-bin/ValCard";
$port="443";

if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: secpay.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -cctype        +     Credit card type
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
	 -cccv2         -     CV2 code
     -bname         +     Name as it appear on Credit Card
     -pemail        +     Customer E-Mail
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
     -saddr         +     Shiping Street Address
     -scity         +     Shiping City Address
     -sstate        +     Shiping State Address (required for US only)
     -szip          +     Shiping Zip Address
     -scountry      +     Shiping 2 Character Country Code
	 -test          +     TEST MODE (true/false/live)
	 -rqcv2         +     Require the CVV2 check digit
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -login         +     Merchant's username 
     -tranid        +     Trasaction Id
EOF
exit;
}

foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}

### --- Check for required parameters
if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-cctype'} eq "")
{
	print "2,Invalid '-cctype' value";
	exit;
}

if ($arg{'-bname'} eq "")
{
	print "2,Invalid '-bname' value";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bcity'} eq "")
{
	print "2,Invalid '-bcity' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if ($arg{'-bcountry'} eq "")
{
	print "2,Invalid '-bcountry' value";
	exit;
}

if ($arg{'-login'} eq "")
{
	print "2,Invalid '-login' value";
	exit;
}

if ($arg{'-tranid'} eq "")
{
	print "2,Invalid '-tranid' value";
	exit;
}

if ($arg{'-saddr'} eq "")
{
	print "2,Invalid '-saddr' value";
	exit;
}

if ($arg{'-scity'} eq "")
{
	print "2,Invalid '-scity' value";
	exit;
}

if ($arg{'-szip'} eq "")
{
	print "2,Invalid '-szip' value";
	exit;
}

if ($arg{'-scountry'} eq "")
{
	print "2,Invalid '-scountry' value";
	exit;
}

if (($arg{'-rqcv2'} ne "true")&&($arg{'-rqcv2'} ne "false"))
{
	print "2,Invalid '-rqcv2' value ".$arg{'-rqcv2'};
	exit;
}

if (($arg{'-test'} ne "true")&&($arg{'-test'} ne "false")&&($arg{'-test'} ne "live"))
{
	print "2,Invalid '-test' value";
	exit;
}
##------------------------------------------------------------------


($page, $response, %reply_headers)=post_https($host, $port, $script,
 make_headers(
  'User-Agent' => 'X-Cart'
 ),
 make_form (
 'card_no' => $arg{'-ccnum'},
 'card_type' => $arg{'-cctype'},
 'expiry' => $arg{'-ccexpdate'},
 'amount' => $arg{'-ccamount'},
 'customer' => $arg{'-bname'},
 'bill_name' => $arg{'-bname'},
 'bill_email' => $arg{'-pemail'},
 'bill_addr_1' => $arg{'-baddr'},
 'bill_city' => $arg{'-bcity'},
 'bill_state' => $arg{'-bstate'},
 'bill_country' => $arg{'-bcountry'},
 'bill_post_code' => $arg{'-bzip'},
 'ship_addr_1' => $arg{'-saddr'},
 'ship_city' => $arg{'-scity'},
 'ship_state' => $arg{'-sstate'},
 'ship_country' => $arg{'-scountry'},
 'ship_post_code' => $arg{'-szip'},
 'merchant' => $arg{'-login'},
 'trans_id' => $arg{'-tranid'},
 'options' => "test_status=".$arg{'-test'}.",dups=false".(($arg{'-cccv2'} ne "")?(",cv2=".$arg{'-cccv2'}):("")).$arg{'-rqcv2'}
 ));

#test payflow response :)
@lines=split ('&',substr($page,1));

foreach $item (@lines)
{
	($key, $val) = split('=',$item);
	$resp{$key}=urldecode($val) if ($key ne "");
}

if(lc($resp{"valid"}) eq "true")
{
  print "1,Success";
}
else
{ 
  @s=split("",$resp{code});
  $retcode="";$f=0;
  for($i=0;$i<scalar(@s);$i++)
  { 
	  if(@s[$i] eq ":"){$f=1;}
	  if(@s[$i] eq "A"){$retcode.=($f)?("Pre-bank checks. Amount not supplied or invalid<br>"):("Transaction authorised by bank. auth_code available as bank reference<br>");}
	  if(@s[$i] eq "N"){$retcode.=($f)?("Pre-bank checks. Customer name not supplied<br>"):("Transaction not authorised. Failure message text available to merchant<br>");}
	  if(@s[$i] eq "C"){$retcode.=($f)?("Pre-bank checks. Card number fails LUHN check<br>"):("Communication problem. Trying again later may well work<br>");}
	  if(@s[$i] eq "P"){$retcode.=($f)?("Pre-bank checks. Same payment presented twice<br>"):("");}
	  if(@s[$i] eq "X"){$retcode.="Pre-bank checks. Not all mandatory parameters supplied<br>";}
	  if(@s[$i] eq "S"){$retcode.="Pre-bank checks. Start date invalid<br>";}
	  if(@s[$i] eq "E"){$retcode.="Pre-bank checks. Expiry date invalid<br>";}
	  if(@s[$i] eq "I"){$retcode.="Pre-bank checks. Issue number invalid<br>";}
	  if(@s[$i] eq "T"){$retcode.="Pre-bank checks. Card type invalid - i.e. does not match card number prefix<br>";}
	  if(@s[$i] eq "M"){$retcode.="Pre-bank checks. Merchant does not exist or not registered yet<br>";}
	  if(@s[$i] eq "B"){$retcode.="Pre-bank checks. Merchant account for card type does not exist<br>";}
	  if(@s[$i] eq "D"){$retcode.="Pre-bank checks. Merchant account for this currency does not exist<br>";}
	  if(@s[$i] eq "V"){$retcode.="Pre-bank checks. CVV2 security code mandatory and not supplied / invalid<br>";}
 }

  print "2,".$retcode;
}
