#!/usr/bin/perl

#
# $Id: verisignl.pl,v 1.3 2002/09/17 06:11:37 sdg Exp $
#

#
# Mirror from Plug n Pay script
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));
#use MD5;

sub urldecode
{
	local($val2)=@_;
	$val2=~ s/\+/ /g;
	$val2=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C',hex($1))/ge;
	return $val2;
}


$host="payflowlink.verisign.com";
$script="/payflowlink.cfm";
$port="443";

if (!($#ARGV+1)) 
{
 print <<EOF;
 Usage: verisignl.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
     -bname         +     Name as it appear on Credit Card
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -login         +     Merchant's username 
     -partner       +     Merchant's partner
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters
if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname'} eq "")
{
	print "2,Invalid '-bname' value";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bcity'} eq "")
{
	print "2,Invalid '-bcity' value";
	exit;
}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if ($arg{'-bcountry'} eq "")
{
	print "2,Invalid '-bcountry' value";
	exit;
}

if ($arg{'-login'} eq "")
{
	print "2,Invalid '-login' value";
	exit;
}

if ($arg{'-partner'} eq "")
{
	print "2,Invalid '-partner' value";
	exit;
}

##------------------------------------------------------------------


($page, $response, %reply_headers)=post_https($host, $port, $script,
 make_headers(
  'User-Agent' => 'X-Cart'
 ),
 make_form (
 'orderform' => 'false',
 'showconfirm' => 'false',
 'echodata' => 'false',
 'method' => 'cc',
 'type' => 'S',
 'login' => $arg{'-login'},
 'partner' => $arg{'-partner'},
 'amount' => $arg{'-ccamount'},
 'name' => $arg{'-bname'},
 'address' => $arg{'-baddr'},
 'city' => $arg{'-bcity'},
 'cardnum' => $arg{'-ccnum'},
 'expdate' => $arg{'-ccexpdate'},
 'state' => $arg{'-bstate'},
 'zip' => $arg{'-bzip'},
 'country' => $arg{'-bcountry'}
));

@res = grep(/name=\"RESPMSG\"/, split("\n", $page));
#test payflow response :)
#open(F,">/tmp/test-verisign");print F @res;close(F);
$isSuccess = 0;

foreach $item (@res)
{
	$isSuccess=1 if($item = ~/Approved/i);
}

print (($isSuccess)?("1,Success"):("2,Declined"));
