<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 RRF.ru development. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The RRF.RU DEVELOPMENT forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE RRF.RU DEVELOPMENT TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE RRF.RU DEVELOPMENT TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is RRF.ru development.           |
| Portions created by RRF.ru development are Copyright (C) 2001-2002          |
| RRF.ru development. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: calendar.php,v 1.1.2.1 2003/01/14 06:39:01 basil Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#
# Search of coincidence date_s and data in $pay_dates array (timestamp)
#
function is_date_pay($date_s)
{
    global $pay_dates;
    if (is_array($pay_dates))
        foreach($pay_dates as $cdate)
            if ($cdate == $date_s) return $date_s;
    return "";
}

$year = date("Y");

if ($REQUEST_METHOD == "POST") {

    $i = 0;
    foreach ($pay_dates_array as $pay_date)
    {
        if ($pay_date)
        {
            $tmp[] = $pay_date;
//            echo $productid.": ".$i.". ".date("m/d/Y",$pay_date)."<br>";
        }
        $i++;
    }
    sort($tmp);
    //reset($tmp);
    $query = "update $sql_tbl[subscriptions] set pay_dates='".Serialize($tmp)."' where productid='$productid'";
    db_query($query);
    header("Location: calendar.php?productid=$productid");
}

#
# Retrieve $pay_dates array from database or if it's empty filling it
#
$query = "select s.*, p.product from $sql_tbl[subscriptions] as s, $sql_tbl[products] as p where s.productid=p.productid and s.productid='$productid'";
$subscription_info = func_query_first($query);

$product_name = $subscription_info[product];

$pay_type = is_numeric($subscription_info[pay_period_type])?"By Period (".$subscription_info[pay_period_type]." days)":$subscription_info[pay_period_type];

$pay_dates = array();
if ($subscription_info[pay_dates] && empty($reset) && empty($reset2nil))
    $pay_dates = Unserialize($subscription_info[pay_dates]);
elseif (!empty($reset2nil))
    $pay_dates = array();
else {
    switch($subscription_info[pay_period_type]) {
        case "Annually":
            $pay_dates[] = mktime(0,0,0,1,1,$year);
            break;
        case "Quarterly":
            $pay_dates[] = mktime(0,0,0,1,1,$year);
            $pay_dates[] = mktime(0,0,0,4,1,$year);
            $pay_dates[] = mktime(0,0,0,7,1,$year);
            $pay_dates[] = mktime(0,0,0,10,1,$year);
            break;
        case "Monthly":
            for($i = 1; $i <= 12; $i++) {
                $pay_dates[] = mktime(0,0,0,$i,1,$year);  # for start of months
//               $pay_dates[] = (checkdate($i,31,$year)?mktime(0,0,0,$i,31,$year):(checkdate($i,30,$year)?mktime(0,0,0,$i,30,$year):(checkdate($i,29,$year)?mktime(0,0,0,$i,29,$year):mktime(0,0,0,$i,28,$year)))); # for end of months
            }
            break;
        case "Weekly":
            $first_day = mktime(0,0,0,1,1,$year);
            $last_day = mktime(0,0,0,12,31,$year);
            for($i = $first_day; $i <= $last_day; $i+=86400)
                if (date("w",$i) == 1)
                    $pay_dates[] = mktime(0,0,0,date("m",$i),date("d",$i),$year);
            break;
        default: # By Period
            $first_day = time();
            $last_day = mktime(0,0,0,12,31,$year);
            for($i = $first_day; $i <= $last_day; $i+=(86400*$subscription_info[pay_period_type])) {
                $pay_dates[] = mktime(0,0,0,date("m",$i),date("d",$i),$year);
            }
    }
}

#
# Filling array of months for $year
#
$year_array = array();
$days_array = array();

for($mn = 0; $mn < 12; $mn++) {

    $month_array = array();
    $wnum = 0;
    $flag = false;
    $date_s = "";

    for($day = 1; $day < 32 && checkdate($mn+1,$day,$year); $day++) {
        $date_s = mktime(0,0,0,$mn+1,$day,$year);
        $date_array = getdate($date_s);
        if (is_date_pay($date_s)) {
            $month_array[$date_array["wday"]][$wnum]["date"] = $date_s;
            $days_array[] = $date_s;
        }
        else
            $days_array[] = "";
        $month_array[$date_array["wday"]][$wnum]["day"] = $date_s;
        $month_array[$date_array["wday"]][$wnum]["dayofyear"] = $date_array["yday"];
        $flag = true;
        if ($date_array["wday"] == 6) { $wnum++; $flag = false; }
    }

    $wnum++;
    if (!$flag) $wnum--;
    
    $year_tmp[wnum] = $wnum;
    $year_tmp[month_array] = $month_array;
    $year_tmp[month] = mktime(0,0,0,$mn+1,1,$year);
    $year_array[] = $year_tmp;
}


$smarty->assign("year_array", $year_array);
$smarty->assign("days_array", $days_array);
$smarty->assign("current_date", mktime(0,0,0,date("m"),date("d"),$year));
$smarty->assign("product", $product_name);
$smarty->assign("productid", $productid);
$smarty->assign("pay_type", $pay_type);

$smarty->display("admin/main/calendar.tpl");


?>
