<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: export.php,v 1.16.2.2 2003/03/12 13:37:29 svowl Exp $
#

set_time_limit(1800);

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#
# Use this condition when single mode is disabled
#   
$provider_condition = ($single_mode ? "" : "AND $sql_tbl[products].provider='$login'");

$chunk_size = 35;

if ($mode == "Export products") {

	$search_query = "SELECT $sql_tbl[products].*, $sql_tbl[categories].category, MIN($sql_tbl[pricing].price) AS price FROM $sql_tbl[products], $sql_tbl[pricing], $sql_tbl[categories] WHERE $sql_tbl[pricing].productid=$sql_tbl[products].productid AND $sql_tbl[pricing].quantity=1 AND $sql_tbl[products].categoryid=$sql_tbl[categories].categoryid AND $sql_tbl[pricing].membership='' $provider_condition GROUP BY $sql_tbl[products].productid ORDER BY $sql_tbl[products].productid";

	$result = db_query($search_query);

	$total_products = db_num_rows($result);
	
	if ($total_products > 0) {

		header("Content-type: text/csv");
		header("Content-disposition: attachment; filename=products.csv");

		$_tmp_smarty_debug = $smarty->debugging;
		$smarty->debugging = false;

		$smarty->assign("delimiter", $delimiter);

		$counter = 0;

		while ($product_data = db_fetch_array($result)) {
					
			if (is_array($product_data)) {
				foreach ($product_data as $key => $value) {
					$product_data[$key] = strtr($value, "\r\n\t", "");
					$product_data[$key] = "\"".str_replace("\"", "\"\"", $product_data[$key])."\"";
				}
			}

			$products[] = $product_data;
			$counter++;

			if ($counter%$chunk_size==0 || $counter==$total_products) {
				$smarty->assign("products", $products);
				$smarty->display("main/products_export.tpl");
				flush();
				unset($products);
			}
	
		}
		
		$smarty->debugging = $_tmp_smarty_debug;
		exit;
	}
	else {
		header("Location: export.php?err=noproducts");
		exit;
	}
}

$smarty->assign("products", $products);
$smarty->assign("main", "export");

@include "../modules/gold_display.php";
$smarty->display("provider/home.tpl");
?>
