# MySQL dump 8.14
#
# Host: localhost    Database: svowl_eshop_stable3
#--------------------------------------------------------
# Server version	3.23.54

#
# Table structure for table 'xcart_categories'
#

CREATE TABLE xcart_categories (
  categoryid int(11) NOT NULL auto_increment,
  image_x int(11) NOT NULL default '0',
  image_y int(11) NOT NULL default '0',
  category varchar(255) NOT NULL default '',
  description text NOT NULL,
  meta_tags varchar(255) NOT NULL default '',
  avail char(1) NOT NULL default 'Y',
  views_stats int(11) NOT NULL default '0',
  order_by int(11) NOT NULL default '0',
  membership varchar(32) NOT NULL default '',
  threshold_bestsellers int(11) NOT NULL default '1',
  PRIMARY KEY  (categoryid),
  KEY order_by (order_by),
  KEY category (category)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_cc_gestpay_data'
#

CREATE TABLE xcart_cc_gestpay_data (
  value char(32) NOT NULL default '',
  type char(1) NOT NULL default 'C',
  PRIMARY KEY  (value,type)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_cc_pp3_data'
#

CREATE TABLE xcart_cc_pp3_data (
  ref char(255) NOT NULL default '',
  amount decimal(12,2) NOT NULL default '0.00',
  currency char(3) NOT NULL default '',
  status char(1) NOT NULL default '',
  sessionid char(255) NOT NULL default '',
  UNIQUE KEY ref (ref)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_ccprocessors'
#

CREATE TABLE xcart_ccprocessors (
  module_name varchar(255) NOT NULL default '',
  processor varchar(255) NOT NULL default '',
  template varchar(255) NOT NULL default '',
  param01 varchar(255) NOT NULL default '',
  param02 varchar(255) NOT NULL default '',
  param03 varchar(255) NOT NULL default '',
  param04 varchar(255) NOT NULL default '',
  param05 varchar(255) NOT NULL default '',
  param06 varchar(255) NOT NULL default '',
  param07 varchar(255) NOT NULL default '',
  param08 varchar(255) NOT NULL default '',
  param09 varchar(255) NOT NULL default '',
  disable_ccinfo enum('Y','N') NOT NULL default 'N',
  PRIMARY KEY  (module_name),
  KEY module_name (module_name)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_chprocessors'
#

CREATE TABLE xcart_chprocessors (
  module_name varchar(255) NOT NULL default '',
  processor varchar(255) NOT NULL default '',
  template varchar(255) NOT NULL default '',
  param01 varchar(255) NOT NULL default '',
  param02 varchar(255) NOT NULL default '',
  param03 varchar(255) NOT NULL default '',
  param04 varchar(255) NOT NULL default '',
  param05 varchar(255) NOT NULL default '',
  param06 varchar(255) NOT NULL default '',
  param07 varchar(255) NOT NULL default '',
  param08 varchar(255) NOT NULL default '',
  param09 varchar(255) NOT NULL default '',
  disable_chinfo enum('Y','N') NOT NULL default 'N',
  PRIMARY KEY  (module_name),
  KEY module_name (module_name)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_config'
#

CREATE TABLE xcart_config (
  name varchar(32) NOT NULL default '',
  comment varchar(255) NOT NULL default '',
  value text NOT NULL,
  category varchar(32) NOT NULL default '',
  orderby int(11) NOT NULL default '0',
  type enum('text','textarea','checkbox') default 'text',
  PRIMARY KEY  (name),
  KEY orderby (orderby),
  KEY name (name)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_countries'
#

CREATE TABLE xcart_countries (
  country varchar(50) NOT NULL default '',
  code char(2) NOT NULL default '',
  language varchar(32) NOT NULL default '',
  charset varchar(32) NOT NULL default 'iso-8859-1',
  KEY code (code),
  KEY country (country)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_country_tax'
#

CREATE TABLE xcart_country_tax (
  taxid int(11) NOT NULL auto_increment,
  code char(2) NOT NULL default '',
  provider char(32) NOT NULL default '',
  tax_percent decimal(12,2) NOT NULL default '0.00',
  tax_flat decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (taxid),
  KEY provider (provider),
  KEY code (code)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_country_zones'
#

CREATE TABLE xcart_country_zones (
  zoneid int(11) NOT NULL default '0',
  code char(2) NOT NULL default '',
  provider char(32) NOT NULL default '',
  PRIMARY KEY  (code,provider),
  KEY zoneid (zoneid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_customers'
#

CREATE TABLE xcart_customers (
  login varchar(32) NOT NULL default '',
  usertype char(1) NOT NULL default '',
  membership varchar(32) NOT NULL default '',
  password varchar(64) NOT NULL default '',
  password_hint varchar(128) NOT NULL default '',
  password_hint_answer varchar(128) NOT NULL default '',
  b_address varchar(64) NOT NULL default '',
  b_city varchar(64) NOT NULL default '',
  b_state varchar(32) NOT NULL default '',
  b_country char(2) NOT NULL default '',
  b_zipcode varchar(32) NOT NULL default '',
  title varchar(32) NOT NULL default '',
  firstname varchar(128) NOT NULL default '',
  lastname varchar(128) NOT NULL default '',
  company varchar(255) NOT NULL default '',
  s_address varchar(255) NOT NULL default '',
  s_city varchar(255) NOT NULL default '',
  s_state varchar(32) NOT NULL default '',
  s_country char(2) NOT NULL default '',
  s_zipcode varchar(32) NOT NULL default '',
  email varchar(128) NOT NULL default '',
  phone varchar(32) NOT NULL default '',
  fax varchar(32) NOT NULL default '',
  url varchar(128) NOT NULL default '',
  card_name varchar(255) NOT NULL default '',
  card_type varchar(16) NOT NULL default '',
  card_number varchar(42) NOT NULL default '',
  card_expire varchar(4) NOT NULL default '',
  card_cvv2 char(3) NOT NULL default '',
  last_login int(11) NOT NULL default '0',
  first_login int(11) NOT NULL default '0',
  status char(1) NOT NULL default 'Y',
  referer varchar(255) NOT NULL default '',
  pending_membership varchar(32) NOT NULL default '',
  ssn varchar(32) NOT NULL default '',
  language char(2) NOT NULL default 'US',
  PRIMARY KEY  (login),
  UNIQUE KEY login (login),
  KEY usertype (usertype),
  KEY membership (membership),
  KEY last_login (last_login),
  KEY first_login (first_login),
  KEY status (status)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_delivery'
#

CREATE TABLE xcart_delivery (
  shippingid int(11) NOT NULL default '0',
  productid int(11) NOT NULL default '0',
  PRIMARY KEY  (shippingid,productid),
  KEY shippingid_index (shippingid),
  KEY productid_index (productid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_discount_coupons'
#

CREATE TABLE xcart_discount_coupons (
  coupon char(16) NOT NULL default '',
  discount decimal(12,2) NOT NULL default '0.00',
  coupon_type char(12) NOT NULL default '',
  productid int(11) NOT NULL default '0',
  categoryid int(11) NOT NULL default '0',
  minimum int(11) NOT NULL default '0',
  times int(11) NOT NULL default '0',
  times_used int(11) NOT NULL default '0',
  expire int(11) NOT NULL default '0',
  status char(1) NOT NULL default '',
  provider char(32) NOT NULL default '',
  PRIMARY KEY  (coupon),
  KEY provider (provider),
  KEY status (status)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_discounts'
#

CREATE TABLE xcart_discounts (
  discountid int(11) NOT NULL auto_increment,
  minprice decimal(12,2) NOT NULL default '0.00',
  discount decimal(12,2) NOT NULL default '0.00',
  discount_type char(32) NOT NULL default 'absolute',
  provider char(32) NOT NULL default '',
  membership char(32) NOT NULL default '',
  PRIMARY KEY  (discountid),
  KEY provider (provider),
  KEY minprice (minprice),
  KEY membership (membership)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_download_keys'
#

CREATE TABLE xcart_download_keys (
  download_key char(100) NOT NULL default '',
  expires int(11) NOT NULL default '0',
  productid int(11) NOT NULL default '0',
  PRIMARY KEY  (download_key),
  KEY productid (productid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_extra_fields'
#

CREATE TABLE xcart_extra_fields (
  fieldid int(11) NOT NULL auto_increment,
  provider char(32) NOT NULL default '',
  field char(255) NOT NULL default '',
  value char(255) NOT NULL default '',
  active char(1) NOT NULL default 'Y',
  PRIMARY KEY  (fieldid),
  KEY provider (provider),
  KEY active (active)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_featured_products'
#

CREATE TABLE xcart_featured_products (
  productid int(11) NOT NULL default '0',
  categoryid int(11) NOT NULL default '0',
  product_order int(11) NOT NULL default '0',
  avail char(1) NOT NULL default 'Y',
  PRIMARY KEY  (productid,categoryid),
  KEY product_order (product_order),
  KEY avail (avail)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_giftcerts'
#

CREATE TABLE xcart_giftcerts (
  gcid varchar(16) NOT NULL default '',
  orderid int(11) NOT NULL default '0',
  purchaser varchar(64) NOT NULL default '',
  recipient varchar(64) NOT NULL default '',
  send_via char(1) NOT NULL default 'E',
  recipient_email varchar(64) NOT NULL default '',
  recipient_firstname varchar(128) NOT NULL default '',
  recipient_lastname varchar(128) NOT NULL default '',
  recipient_address varchar(64) NOT NULL default '',
  recipient_city varchar(64) NOT NULL default '',
  recipient_state varchar(32) NOT NULL default '',
  recipient_zipcode varchar(32) NOT NULL default '',
  recipient_country char(2) NOT NULL default '',
  recipient_phone varchar(32) NOT NULL default '',
  message text NOT NULL,
  amount decimal(12,2) NOT NULL default '0.00',
  debit decimal(12,2) NOT NULL default '0.00',
  status char(1) NOT NULL default 'P',
  add_date int(11) NOT NULL default '0',
  block_date int(11) NOT NULL default '0',
  PRIMARY KEY  (gcid),
  KEY orderid (orderid),
  KEY status (status),
  KEY add_date (add_date)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_icons'
#

CREATE TABLE xcart_icons (
  categoryid int(11) NOT NULL default '0',
  image blob NOT NULL,
  image_type varchar(64) NOT NULL default 'image/jpeg',
  PRIMARY KEY  (categoryid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_images'
#

CREATE TABLE xcart_images (
  imageid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  image mediumblob NOT NULL,
  image_type varchar(64) NOT NULL default 'image/jpeg',
  image_x int(11) NOT NULL default '0',
  image_y int(11) NOT NULL default '0',
  image_size int(11) NOT NULL default '0',
  alt varchar(255) NOT NULL default '',
  avail char(1) NOT NULL default 'Y',
  PRIMARY KEY  (imageid),
  KEY productid (productid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_languages'
#

CREATE TABLE xcart_languages (
  code char(2) NOT NULL default '',
  descr varchar(128) NOT NULL default '',
  name varchar(128) NOT NULL default '',
  value text NOT NULL,
  topic varchar(24) NOT NULL default '',
  PRIMARY KEY  (code,name)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_login_history'
#

CREATE TABLE xcart_login_history (
  login char(32) NOT NULL default '',
  date_time int(11) NOT NULL default '0',
  usertype char(1) NOT NULL default '',
  action char(32) NOT NULL default '',
  status char(32) NOT NULL default '',
  ip char(32) NOT NULL default '',
  PRIMARY KEY  (login,date_time)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_maillist'
#

CREATE TABLE xcart_maillist (
  email char(128) NOT NULL default '',
  since_date int(11) NOT NULL default '0',
  PRIMARY KEY  (email)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_modules'
#

CREATE TABLE xcart_modules (
  moduleid int(11) NOT NULL auto_increment,
  module_name varchar(255) NOT NULL default '',
  module_descr varchar(255) NOT NULL default '',
  active char(1) NOT NULL default 'Y',
  PRIMARY KEY  (moduleid),
  KEY module_name (module_name),
  KEY active (active)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_newsletter'
#

CREATE TABLE xcart_newsletter (
  newsid int(11) NOT NULL auto_increment,
  subject varchar(128) NOT NULL default '',
  body text NOT NULL,
  send_date int(11) NOT NULL default '0',
  email1 varchar(128) NOT NULL default '',
  email2 varchar(128) NOT NULL default '',
  email3 varchar(128) NOT NULL default '',
  status char(1) NOT NULL default 'N',
  PRIMARY KEY  (newsid),
  KEY status (status),
  KEY send_date (send_date)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_order_details'
#

CREATE TABLE xcart_order_details (
  orderid int(11) NOT NULL default '0',
  productid int(11) NOT NULL default '0',
  price decimal(12,2) NOT NULL default '0.00',
  amount int(11) NOT NULL default '0',
  provider varchar(32) NOT NULL default '',
  product_options text NOT NULL,
  KEY orderid (orderid),
  KEY productid (productid),
  KEY provider (provider)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_orders'
#

CREATE TABLE xcart_orders (
  orderid int(11) NOT NULL auto_increment,
  login varchar(32) NOT NULL default '',
  total decimal(12,2) NOT NULL default '0.00',
  giftcert_discount decimal(12,2) NOT NULL default '0.00',
  giftcert_ids text NOT NULL,
  subtotal decimal(12,2) NOT NULL default '0.00',
  discount decimal(12,2) NOT NULL default '0.00',
  coupon varchar(16) NOT NULL default '',
  coupon_discount decimal(12,2) NOT NULL default '0.00',
  shippingid int(11) NOT NULL default '0',
  tracking varchar(64) NOT NULL default '',
  shipping_cost decimal(12,2) NOT NULL default '0.00',
  tax decimal(12,2) NOT NULL default '0.00',
  date int(11) NOT NULL default '0',
  status char(1) NOT NULL default 'Q',
  payment_method varchar(64) NOT NULL default '',
  flag char(1) NOT NULL default 'N',
  notes text NOT NULL,
  details text NOT NULL,
  customer varchar(32) NOT NULL default '',
  title varchar(32) NOT NULL default '',
  firstname varchar(32) NOT NULL default '',
  lastname varchar(32) NOT NULL default '',
  company varchar(255) NOT NULL default '',
  b_address varchar(64) NOT NULL default '',
  b_city varchar(64) NOT NULL default '',
  b_state varchar(32) NOT NULL default '',
  b_country char(2) NOT NULL default '',
  b_zipcode varchar(32) NOT NULL default '',
  s_address varchar(64) NOT NULL default '',
  s_city varchar(64) NOT NULL default '',
  s_state varchar(32) NOT NULL default '',
  s_country char(2) NOT NULL default '',
  s_zipcode varchar(32) NOT NULL default '',
  phone varchar(32) NOT NULL default '',
  fax varchar(32) NOT NULL default '',
  url varchar(32) NOT NULL default '',
  email varchar(128) NOT NULL default '',
  language char(2) NOT NULL default 'US',
  PRIMARY KEY  (orderid),
  KEY order_date (date),
  KEY s_state (s_state),
  KEY b_state (b_state),
  KEY s_country (s_country),
  KEY b_country (b_country),
  KEY login (login)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_partner_banners'
#

CREATE TABLE xcart_partner_banners (
  banner_id int(11) NOT NULL auto_increment,
  width int(11) NOT NULL default '0',
  height int(11) NOT NULL default '0',
  image blob,
  PRIMARY KEY  (banner_id)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_partner_clicks'
#

CREATE TABLE xcart_partner_clicks (
  login varchar(32) NOT NULL default '',
  add_date int(11) NOT NULL default '0',
  class char(1) NOT NULL default '',
  KEY login (login),
  KEY add_date (add_date)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_partner_commitions'
#

CREATE TABLE xcart_partner_commitions (
  login varchar(32) NOT NULL default '',
  commition decimal(12,2) NOT NULL default '0.00',
  commition_type enum('$','%') NOT NULL default '%',
  PRIMARY KEY  (login)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_partner_payment'
#

CREATE TABLE xcart_partner_payment (
  payment_id int(11) NOT NULL auto_increment,
  login varchar(32) NOT NULL default '',
  orderid int(11) NOT NULL default '0',
  commitions decimal(12,2) NOT NULL default '0.00',
  paid char(1) NOT NULL default 'N',
  add_date int(11) NOT NULL default '0',
  PRIMARY KEY  (payment_id),
  KEY login (login),
  KEY orderid (orderid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_partner_views'
#

CREATE TABLE xcart_partner_views (
  login varchar(32) NOT NULL default '',
  add_date int(11) NOT NULL default '0',
  class char(1) NOT NULL default '',
  KEY login (login)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_payment_methods'
#

CREATE TABLE xcart_payment_methods (
  paymentid int(11) NOT NULL auto_increment,
  payment_method char(128) NOT NULL default '',
  payment_details char(255) NOT NULL default '',
  payment_template char(128) NOT NULL default '',
  payment_script char(128) NOT NULL default '',
  protocol char(6) NOT NULL default 'http',
  membership char(32) NOT NULL default '',
  orderby int(11) NOT NULL default '0',
  active char(1) NOT NULL default 'Y',
  PRIMARY KEY  (paymentid),
  KEY orderby (orderby)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_php_sessions'
#

CREATE TABLE xcart_php_sessions (
  SessionID varchar(32) NOT NULL default '',
  LastActive int(11) NOT NULL default '0',
  Data text,
  PRIMARY KEY  (SessionID)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_pricing'
#

CREATE TABLE xcart_pricing (
  priceid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  quantity int(11) NOT NULL default '0',
  price decimal(12,2) NOT NULL default '0.00',
  membership char(32) NOT NULL default '',
  PRIMARY KEY  (priceid),
  KEY productid (productid),
  KEY membership (membership)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_bookmarks'
#

CREATE TABLE xcart_product_bookmarks (
  productid int(11) NOT NULL default '0',
  add_date int(11) NOT NULL default '0',
  login char(32) NOT NULL default '',
  UNIQUE KEY productid (productid,login)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_links'
#

CREATE TABLE xcart_product_links (
  productid1 int(11) NOT NULL default '0',
  productid2 int(11) NOT NULL default '0',
  orderby int(11) NOT NULL default '0',
  KEY productid2 (productid2),
  KEY productid1 (productid1),
  KEY orderby (orderby)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_options'
#

CREATE TABLE xcart_product_options (
  optionid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  optclass varchar(128) NOT NULL default '',
  opttext varchar(255) NOT NULL default '',
  options text NOT NULL,
  orderby int(11) NOT NULL default '0',
  PRIMARY KEY  (optionid),
  KEY productid (productid),
  KEY orderby (orderby)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_options_ex'
#

CREATE TABLE xcart_product_options_ex (
  optionid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  exception varchar(128) NOT NULL default '',
  PRIMARY KEY  (optionid),
  KEY productid (productid,exception)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_options_js'
#

CREATE TABLE xcart_product_options_js (
  productid int(11) NOT NULL default '0',
  javascript_code text
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_reviews'
#

CREATE TABLE xcart_product_reviews (
  review_id int(11) NOT NULL auto_increment,
  remote_ip varchar(15) NOT NULL default '',
  email varchar(128) NOT NULL default '',
  message varchar(255) NOT NULL default '',
  productid int(11) NOT NULL default '0',
  PRIMARY KEY  (review_id),
  KEY productid (productid),
  KEY remote_ip (remote_ip)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_product_votes'
#

CREATE TABLE xcart_product_votes (
  vote_id int(11) NOT NULL auto_increment,
  remote_ip varchar(15) NOT NULL default '',
  vote_value int(1) NOT NULL default '0',
  productid int(11) NOT NULL default '0',
  PRIMARY KEY  (vote_id),
  KEY remote_ip (remote_ip),
  KEY productid (productid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_products'
#

CREATE TABLE xcart_products (
  productid int(11) NOT NULL auto_increment,
  productcode varchar(32) NOT NULL default '',
  product varchar(255) NOT NULL default '',
  provider varchar(32) NOT NULL default '',
  brand varchar(255) NOT NULL default '',
  model varchar(255) NOT NULL default '',
  distribution varchar(255) NOT NULL default '',
  weight decimal(12,2) NOT NULL default '0.00',
  categoryid int(11) NOT NULL default '0',
  categoryid1 int(11) NOT NULL default '0',
  categoryid2 int(11) NOT NULL default '0',
  categoryid3 int(11) NOT NULL default '0',
  discount int(11) NOT NULL default '0',
  descr text NOT NULL,
  fulldescr text NOT NULL,
  avail int(11) NOT NULL default '0',
  rating int(11) NOT NULL default '0',
  forsale char(1) NOT NULL default 'Y',
  add_date int(11) NOT NULL default '0',
  image_x int(11) NOT NULL default '0',
  image_y int(11) NOT NULL default '0',
  views_stats int(11) NOT NULL default '0',
  sales_stats int(11) NOT NULL default '0',
  del_stats int(11) NOT NULL default '0',
  shipping_freight decimal(12,2) NOT NULL default '0.00',
  free_shipping char(1) NOT NULL default 'N',
  discount_avail char(1) default '',
  param00 varchar(255) NOT NULL default '',
  param01 varchar(255) NOT NULL default '',
  param02 varchar(255) NOT NULL default '',
  param03 varchar(255) NOT NULL default '',
  param04 varchar(255) NOT NULL default '',
  param05 varchar(255) NOT NULL default '',
  param06 varchar(255) NOT NULL default '',
  param07 varchar(255) NOT NULL default '',
  param08 varchar(255) NOT NULL default '',
  param09 varchar(255) NOT NULL default '',
  min_amount int(11) NOT NULL default '1',
  dim_x int(11) NOT NULL default '0',
  dim_y int(11) NOT NULL default '0',
  dim_z int(11) NOT NULL default '0',
  low_avail_limit int(11) NOT NULL default '10',
  orderby int(11) NOT NULL default '0',
  vat decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (productid),
  KEY product (product),
  KEY categoryid1 (categoryid1,categoryid2,categoryid3),
  KEY category (categoryid),
  KEY rating (rating),
  KEY add_date (add_date),
  KEY provider (provider),
  KEY avail (avail),
  KEY orderby (orderby),
  KEY best_sellers (sales_stats,views_stats)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_products_lng'
#

CREATE TABLE xcart_products_lng (
  code char(2) NOT NULL default '',
  productid int(11) NOT NULL default '0',
  descr text NOT NULL,
  full_descr text NOT NULL
) TYPE=MyISAM;

#
# Table structure for table 'xcart_referers'
#

CREATE TABLE xcart_referers (
  referer char(255) NOT NULL default '',
  visits int(11) NOT NULL default '0',
  last_visited int(11) NOT NULL default '0',
  PRIMARY KEY  (referer)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_shipping'
#

CREATE TABLE xcart_shipping (
  shippingid int(11) NOT NULL auto_increment,
  shipping varchar(128) NOT NULL default '',
  shipping_time varchar(128) NOT NULL default '',
  destination char(1) NOT NULL default 'I',
  code varchar(32) NOT NULL default '',
  subcode varchar(32) NOT NULL default '',
  orderby int(11) NOT NULL default '0',
  active char(1) NOT NULL default 'Y',
  ups_service varchar(32) NOT NULL default '',
  weight_limit decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (shippingid),
  KEY code (code),
  KEY orderby (orderby)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_shipping_options'
#

CREATE TABLE xcart_shipping_options (
  carrier varchar(32) NOT NULL default '',
  param00 varchar(128) NOT NULL default '',
  param01 varchar(128) NOT NULL default '',
  param02 varchar(128) NOT NULL default '',
  param03 varchar(128) NOT NULL default '',
  param04 varchar(128) NOT NULL default '',
  param05 varchar(128) NOT NULL default '',
  param06 varchar(128) NOT NULL default '',
  param07 varchar(128) NOT NULL default '',
  param08 varchar(128) NOT NULL default '',
  param09 varchar(128) NOT NULL default '',
  PRIMARY KEY  (carrier)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_shipping_rates'
#

CREATE TABLE xcart_shipping_rates (
  rateid int(11) NOT NULL auto_increment,
  shippingid int(11) NOT NULL default '0',
  zoneid int(11) NOT NULL default '0',
  maxamount int(11) NOT NULL default '1000000',
  maxweight decimal(12,2) NOT NULL default '1000000.00',
  maxtotal decimal(12,2) NOT NULL default '0.00',
  rate decimal(12,2) NOT NULL default '0.00',
  item_rate decimal(12,2) NOT NULL default '0.00',
  weight_rate decimal(12,2) NOT NULL default '0.00',
  rate_p decimal(12,2) NOT NULL default '0.00',
  provider char(32) NOT NULL default '',
  type char(1) NOT NULL default 'D',
  PRIMARY KEY  (rateid),
  KEY provider (provider),
  KEY shippingid (shippingid),
  KEY maxamount (maxamount),
  KEY maxweight (maxweight),
  KEY zoneid (zoneid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_state_tax'
#

CREATE TABLE xcart_state_tax (
  taxid int(11) NOT NULL auto_increment,
  code char(32) NOT NULL default '',
  provider char(32) NOT NULL default '',
  tax_percent decimal(12,2) NOT NULL default '0.00',
  tax_flat decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (taxid),
  KEY code (code),
  KEY provider (provider)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_state_zones'
#

CREATE TABLE xcart_state_zones (
  zoneid int(11) NOT NULL default '0',
  code char(32) NOT NULL default '',
  provider char(32) NOT NULL default '',
  PRIMARY KEY  (code,provider),
  KEY zoneid (zoneid,code,provider)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_states'
#

CREATE TABLE xcart_states (
  stateid int(11) NOT NULL auto_increment,
  state varchar(32) NOT NULL default '',
  code varchar(32) NOT NULL default '',
  PRIMARY KEY  (stateid),
  KEY state (state),
  KEY code (code)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_stats_cart_funnel'
#

CREATE TABLE xcart_stats_cart_funnel (
  transactionid int(11) NOT NULL auto_increment,
  login varchar(32) NOT NULL default '',
  start_page int(11) NOT NULL default '0',
  step1 int(11) NOT NULL default '0',
  step2 int(11) NOT NULL default '0',
  step3 int(11) NOT NULL default '0',
  final_page int(11) NOT NULL default '0',
  date int(11) NOT NULL default '0',
  PRIMARY KEY  (transactionid),
  KEY start_page (start_page),
  KEY step1 (step1),
  KEY step2 (step2),
  KEY step3 (step3),
  KEY final_page (final_page),
  KEY date (date)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_stats_customers_products'
#

CREATE TABLE xcart_stats_customers_products (
  productid int(11) NOT NULL default '0',
  login varchar(32) NOT NULL default '',
  counter int(11) NOT NULL default '0',
  PRIMARY KEY  (productid,login),
  KEY counter (counter)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_stats_pages'
#

CREATE TABLE xcart_stats_pages (
  pageid int(11) NOT NULL auto_increment,
  page varchar(255) NOT NULL default '',
  PRIMARY KEY  (pageid),
  KEY page (page)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_stats_pages_paths'
#

CREATE TABLE xcart_stats_pages_paths (
  path varchar(255) NOT NULL default '',
  date int(11) NOT NULL default '0',
  KEY counter (date),
  KEY path (path)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_stats_pages_views'
#

CREATE TABLE xcart_stats_pages_views (
  pageid int(255) NOT NULL default '0',
  time_avg int(11) NOT NULL default '0',
  date int(11) NOT NULL default '0',
  KEY pageid (pageid),
  KEY time_avg (time_avg),
  KEY date (date)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_stats_shop'
#

CREATE TABLE xcart_stats_shop (
  id int(11) NOT NULL default '0',
  action char(1) NOT NULL default 'V',
  date int(11) NOT NULL default '0',
  KEY id (id),
  KEY date (date),
  KEY action (action)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_subscription_customers'
#

CREATE TABLE xcart_subscription_customers (
  last_payed_date int(11) NOT NULL default '0',
  orderid int(11) NOT NULL default '0',
  productid int(11) NOT NULL default '0',
  login varchar(32) NOT NULL default '',
  last_payed_orderid int(11) NOT NULL default '0',
  subscriptionid int(11) NOT NULL auto_increment,
  subscription_status varchar(50) NOT NULL default 'Active',
  PRIMARY KEY  (subscriptionid),
  KEY last_payed_date (last_payed_date)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_subscriptions'
#

CREATE TABLE xcart_subscriptions (
  productid int(11) NOT NULL default '0',
  pay_period_type varchar(64) NOT NULL default 'Monthly',
  price_period decimal(12,2) NOT NULL default '0.00',
  oneday_price decimal(12,6) NOT NULL default '0.000000',
  days_as_period int(11) NOT NULL default '0',
  pay_dates text,
  KEY productid (productid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_tax_rates'
#

CREATE TABLE xcart_tax_rates (
  rateid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  zoneid int(11) NOT NULL default '0',
  rate_a decimal(12,2) NOT NULL default '0.00',
  rate_p decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (rateid),
  KEY productid (productid),
  KEY zoneid (zoneid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_thumbnails'
#

CREATE TABLE xcart_thumbnails (
  productid int(11) NOT NULL default '0',
  image mediumblob NOT NULL,
  image_type varchar(64) NOT NULL default 'image/jpeg',
  PRIMARY KEY  (productid)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_wishlist'
#

CREATE TABLE xcart_wishlist (
  login char(32) NOT NULL default '',
  productid int(11) NOT NULL default '0',
  amount int(11) NOT NULL default '0',
  PRIMARY KEY  (login,productid),
  KEY login_index (login)
) TYPE=MyISAM;

#
# Table structure for table 'xcart_zipcode_tax'
#

CREATE TABLE xcart_zipcode_tax (
  taxid int(11) NOT NULL auto_increment,
  zipcode_mask char(12) NOT NULL default '',
  provider char(32) NOT NULL default '',
  tax_percent decimal(12,2) NOT NULL default '0.00',
  tax_flat decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (taxid),
  KEY provider (provider)
) TYPE=MyISAM;

